/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_XDIAGNOSERCTL_H__72900834_D59D_11D3_9A95_00500447FC27__INCLUDED_)
#define AFX_XDIAGNOSERCTL_H__72900834_D59D_11D3_9A95_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XDiagnoserCtl.h : Declaration of the CXDiagnoserCtrl ActiveX Control class.
#include "CECDiagnoseDlg.h"
class CYRServer;

/////////////////////////////////////////////////////////////////////////////
// CXDiagnoserCtrl : See XDiagnoserCtl.cpp for implementation.

class CXDiagnoserCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXDiagnoserCtrl)

    // Constructor
public:
    CXDiagnoserCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXDiagnoserCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXDiagnoserCtrl();

    DECLARE_OLECREATE_EX(CXDiagnoserCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXDiagnoserCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXDiagnoserCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXDiagnoserCtrl)     // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXDiagnoserCtrl)
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXDiagnoserCtrl)
    afx_msg void XSetServerInfo(LPCTSTR strUsername, LPCTSTR strPassword);
    afx_msg void XSetActiveProject(LPCTSTR strProjectName);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    afx_msg void AboutBox();

    // Event maps
    //{{AFX_EVENT(CXDiagnoserCtrl)
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXDiagnoserCtrl)
        dispidXSetServerInfo = 1L,
        dispidXSetActiveProject = 2L,
        //}}AFX_DISP_ID
    };
private:
    BOOL m_bConnected;
    // @cmember Reference to the repository server
    CYRServer*  m_pServer;
    CECDiagnoseDlg m_Diagnoser;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XDIAGNOSERCTL_H__72900834_D59D_11D3_9A95_00500447FC27__INCLUDED)
