/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_XINJECTORMONCTL_H__0C210C5A_0BC9_11D4_BD8C_00C04F89E392__INCLUDED_)
#define AFX_XINJECTORMONCTL_H__0C210C5A_0BC9_11D4_BD8C_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XInjectorMonCtl.h : Declaration of the CXInjectorMonCtrl ActiveX Control class.
#include "InjectorMonDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CXInjectorMonCtrl : See XInjectorMonCtl.cpp for implementation.

class CXInjectorMonCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXInjectorMonCtrl)

    // Constructor
public:
    CXInjectorMonCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXInjectorMonCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXInjectorMonCtrl();

    DECLARE_OLECREATE_EX(CXInjectorMonCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXInjectorMonCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXInjectorMonCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXInjectorMonCtrl)       // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXInjectorMonCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnDestroy();
    //}}AFX_MSG
    afx_msg LRESULT OnShowDynGraphs(WPARAM wParam,LPARAM lParam);
    afx_msg LRESULT OnUpdateTitle(WPARAM wParam,LPARAM lParam);
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXInjectorMonCtrl)
    afx_msg void SetRefreshDelay(long nNewValue);
    afx_msg void XInitialise(LPCTSTR szTestRegName);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    // Event maps
    //{{AFX_EVENT(CXInjectorMonCtrl)
    void FireShowDynGraph(LPCTSTR szRegName, LPCTSTR szInjector)
    {
        FireEvent(eventidShowDynGraph,EVENT_PARAM(VTS_BSTR  VTS_BSTR), szRegName, szInjector);
    }
    void FireControlClosing()
    {
        FireEvent(eventidControlClosing,EVENT_PARAM(VTS_NONE));
    }
    void FireUpdateTitle(LPCTSTR szTitle)
    {
        FireEvent(eventidUpdateTitle,EVENT_PARAM(VTS_BSTR), szTitle);
    }
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXInjectorMonCtrl)
        dispidRefreshDelay = 1L,
        dispidXInitialise = 2L,
        eventidShowDynGraph = 1L,
        eventidControlClosing = 2L,
        eventidUpdateTitle = 3L,
        //}}AFX_DISP_ID
    };

private:
    CInjectorMonDlg m_InjectorMonDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XINJECTORMONCTL_H__0C210C5A_0BC9_11D4_BD8C_00C04F89E392__INCLUDED)
