/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XManagerMonCtl.cpp : Implementation of the CXManagerMonCtrl ActiveX Control class.

#include "stdafx.h"
#include "XManagerMon.h"
#include "XManagerMonCtl.h"
#include "XManagerMonPpg.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CXManagerMonCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CXManagerMonCtrl, COleControl)
//{{AFX_MSG_MAP(CXManagerMonCtrl)
ON_WM_CREATE()
ON_WM_SIZE()
ON_WM_ERASEBKGND()
ON_WM_DESTROY()
//}}AFX_MSG_MAP
ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
ON_MESSAGE(WMU_SHOW_DETAILS, OnShowDetails)
ON_MESSAGE(WMU_INJECTOR_VIEW, OnInjectorView)
ON_MESSAGE(WMU_LOGAUDIT, OnLogAudit)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CXManagerMonCtrl, COleControl)
//{{AFX_DISPATCH_MAP(CXManagerMonCtrl)
// NOTE - ClassWizard will add and remove dispatch map entries
//    DO NOT EDIT what you see in these blocks of generated code !
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CXManagerMonCtrl, COleControl)
//{{AFX_EVENT_MAP(CXManagerMonCtrl)
EVENT_CUSTOM("ShowManagerDetails", FireShowManagerDetails, VTS_BSTR)
EVENT_CUSTOM("ShowInjectorView", FireShowInjectorView, VTS_BSTR)
EVENT_CUSTOM("ClosingControl", FireClosingControl, VTS_NONE)
EVENT_CUSTOM("LogAudit", FireLogAudit, VTS_BSTR  VTS_I2)
//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CXManagerMonCtrl, 1)
PROPPAGEID(CXManagerMonPropPage::guid)
END_PROPPAGEIDS(CXManagerMonCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CXManagerMonCtrl, "XMANAGERMON.XManagerMonCtrl.1",
                       0x991bf946, 0x8868, 0x11d3, 0x9a, 0x95, 0, 0x50, 0x4, 0x47, 0xfc, 0x27)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CXManagerMonCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DXManagerMon =
    {
        0x991bf944, 0x8868, 0x11d3, { 0x9a, 0x95, 0, 0x50, 0x4, 0x47, 0xfc, 0x27 }
    };
const IID BASED_CODE IID_DXManagerMonEvents =
    {
        0x991bf945, 0x8868, 0x11d3, { 0x9a, 0x95, 0, 0x50, 0x4, 0x47, 0xfc, 0x27 }
    };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwXManagerMonOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CXManagerMonCtrl, IDS_XMANAGERMON, _dwXManagerMonOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::CXManagerMonCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CXManagerMonCtrl

BOOL CXManagerMonCtrl::CXManagerMonCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // TODO: Verify that your control follows apartment-model threading rules.
    // Refer to MFC TechNote 64 for more information.
    // If your control does not conform to the apartment-model rules, then
    // you must modify the code below, changing the 6th parameter from
    // afxRegApartmentThreading to 0.

    if (bRegister)
        return AfxOleRegisterControlClass(
                   AfxGetInstanceHandle(),
                   m_clsid,
                   m_lpszProgID,
                   IDS_XMANAGERMON,
                   IDB_XMANAGERMON,
                   afxRegApartmentThreading,
                   _dwXManagerMonOleMisc,
                   _tlid,
                   _wVerMajor,
                   _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::CXManagerMonCtrl - Constructor

CXManagerMonCtrl::CXManagerMonCtrl()
{
    InitializeIIDs(&IID_DXManagerMon, &IID_DXManagerMonEvents);

    // TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::~CXManagerMonCtrl - Destructor


CXManagerMonCtrl::~CXManagerMonCtrl()
{
    // TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::OnDraw - Drawing function


void CXManagerMonCtrl::OnDraw(
    CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    // TODO: Replace the following code with your own drawing code.
    if(m_StatusScreen.GetSafeHwnd()==NULL)
    {
        pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
        pdc->TextOut(0,0,"XManagerMon");
    }
}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::DoPropExchange - Persistence support

void CXManagerMonCtrl::DoPropExchange(CPropExchange* pPX)
{
    ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
    COleControl::DoPropExchange(pPX);

    // TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl::OnResetState - Reset control to default state


void CXManagerMonCtrl::OnResetState()
{
    COleControl::OnResetState();  // Resets defaults found in DoPropExchange

    // TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CXManagerMonCtrl message handlers


int CXManagerMonCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (COleControl::OnCreate(lpCreateStruct) == -1)
        return -1;

    m_StatusScreen.Create(IDD_MANAGER_DLG, this);
    m_StatusScreen.ShowWindow(SW_SHOW);
    m_StatusScreen.Invalidate();
    Invalidate();

    return 0;
}

void CXManagerMonCtrl::OnSize(UINT nType, int cx, int cy)
{
    COleControl::OnSize(nType, cx, cy);

    if(m_StatusScreen.m_hWnd != NULL)
    {
        m_StatusScreen.SetWindowPos(this, 0,0,cx,cy,SWP_NOZORDER);
    }
}

LRESULT CXManagerMonCtrl::OnShowDetails(WPARAM nID, LPARAM ptrRegName)
{
    FireShowManagerDetails((LPCTSTR)ptrRegName);
    return 0;
}

BOOL CXManagerMonCtrl::PreTranslateMessage(MSG* pMsg)
{
    if(m_StatusScreen.PreTranslateMessage(pMsg))
        return true;

    return COleControl::PreTranslateMessage(pMsg);
}

BOOL CXManagerMonCtrl::OnEraseBkgnd(CDC* pDC)
{
    return true;
}

LRESULT CXManagerMonCtrl::OnInjectorView(WPARAM nID, LPARAM ptrRegName)
{
    FireShowInjectorView((LPCTSTR)ptrRegName);
    return 0;
}

void CXManagerMonCtrl::OnDestroy()
{
    COleControl::OnDestroy();

    FireClosingControl();
}

LRESULT CXManagerMonCtrl::OnLogAudit(WPARAM nID, LPARAM ptrRegName)
{
    int nState = nID;

    FireLogAudit((LPCTSTR)ptrRegName, nState);
    return 0;
}
