/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_OPTIONSPAGE_H__961AD3D4_D801_11D3_BD76_00C04F89E392__INCLUDED_)
#define AFX_OPTIONSPAGE_H__961AD3D4_D801_11D3_BD76_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionsPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COptionsPage dialog
#include "GenericPage.h"

class COptionsPage : public CGenericPage
{
    DECLARE_DYNCREATE(COptionsPage)

    typedef enum {enTracingNone,enTracingConfiguration,enTracingResults,
                  enTracingPartialDiagnostics,enTracingFullDiagnostics}TracingLevels;

    typedef enum {enDetailsNo,enDetailsYes} RetrieveDetails;

    // Construction
public:
    COptionsPage();
    ~COptionsPage();

    // Dialog Data
    //{{AFX_DATA(COptionsPage)
    enum { IDD = IDD_OPTIONS_PAGE };
    CComboBox   m_ctlRetrieveDetails;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(COptionsPage)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(COptionsPage)
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnDestroy();
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    //Get number of data entries in this page
    int GetNumDataEntries();

    //retrieve a data entry from this page
    bool GetDataEntry(int nEntry,CStringArray& arstrParams);

    //Add a data entry to this page
    void AddDataEntry(const CStringArray& arstrParams);
private:
    CString m_szHtmlHelpFile;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONSPAGE_H__961AD3D4_D801_11D3_BD76_00C04F89E392__INCLUDED_)
