/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_XOTAEDITORCTL_H__1D6CAC84_9CD6_11D3_BD5B_00C04F89E392__INCLUDED_)
#define AFX_XOTAEDITORCTL_H__1D6CAC84_9CD6_11D3_BD5B_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XOTAEditorCtl.h : Declaration of the CXOTAEditorCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CXOTAEditorCtrl : See XOTAEditorCtl.cpp for implementation.
class TScriptRule;
class TRecord;

#include "EditorSheet.h"

class CXOTAEditorCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXOTAEditorCtrl)

    // Constructor
public:
    CXOTAEditorCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXOTAEditorCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXOTAEditorCtrl();

    DECLARE_OLECREATE_EX(CXOTAEditorCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXOTAEditorCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXOTAEditorCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXOTAEditorCtrl)     // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXOTAEditorCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXOTAEditorCtrl)
    afx_msg BOOL LoadTOF(const VARIANT FAR& varPath);
    afx_msg BOOL SaveTOF(const VARIANT FAR& varPath);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    afx_msg void AboutBox();

    // Event maps
    //{{AFX_EVENT(CXOTAEditorCtrl)
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXOTAEditorCtrl)
        dispidLoadTOF = 1L,
        dispidSaveTOF = 2L,
        //}}AFX_DISP_ID
    };

private:
    CEditorSheet m_EditorSheet;

    TScriptRule *m_pRules;
    TRecord *m_pHeaderRecord;

    BOOL ReadTOF(const CString & strTOF);
    BOOL WriteTOF(const CString & strTOF);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XOTAEDITORCTL_H__1D6CAC84_9CD6_11D3_BD5B_00C04F89E392__INCLUDED)
