/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CXProjectTree.h
// --------------
//
//    This is the include file for the CXProjectTree class
//
//=========================================================================

//{{AFX_INCLUDES()
#include "xtree.h"
//}}AFX_INCLUDES
#if !defined(AFX_CXPROJECTTREE_H__06BCDA2D_DE1D_11D2_BCFC_00608CB45114__INCLUDED_)
#define AFX_CXPROJECTTREE_H__06BCDA2D_DE1D_11D2_BCFC_00608CB45114__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CXProjectTree.h : header file
//
#include "CXUserMsg.h"
#include "..\..\Studio\Common\CECSourceFileUtils.h"

/////////////////////////////////////////////////////////////////////////////
// CXProjectTree dialog
class CYRServer;
class CXProjectTree : public CDialog
{
    // Construction
public:
    void EnableMenus(BOOL bEnabaled);
    void RefreshTree();
    CString GetActiveTest();
    void SetActiveProject(CString strProject);
    CXProjectTree(BOOL bUseSCC, CWnd* pParent = NULL);   // standard constructor
    void AddTests(HTREEITEM parent);
    void AddNodes(HTREEITEM parent);

    void AddTestDependencies(HTREEITEM parent, CString szPath);

    void Activate();
    void SetServer(CYRServer* pServer);

    // Dialog Data
    //{{AFX_DATA(CXProjectTree)
    enum { IDD = IDD_PROJECT_TREE };
    CXTree  m_XTreeProject;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXProjectTree)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CXProjectTree)
    afx_msg void OnLBDblClickXtreeProject(long hTreeItem, short nNodeType, LPCTSTR szPath);
    afx_msg void OnXTreeExpandingXtreeProject(long hTreeItem, short nNodeType, LPCTSTR szPath);
    afx_msg void OnXTreeContextClickXtreeProject(LPCTSTR strPath, short nType, LPCTSTR strEntry);
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnXTreeItemProperties(LPCTSTR strPath, short nType);
    afx_msg void OnXShowContext(short nNodeType, LPCTSTR strPath);
    DECLARE_EVENTSINK_MAP()
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
private:
    BOOL m_bUseSCC;
    BOOL IsFileLocked(short nNodeType, CString fileName);
    CString m_WorkDir;
    void GetWorkDir();
    CString m_strProject;
    CString m_strActiveTest;
    CYRServer* m_pServer;

    void    LoadBitmaps ();

    void    GetDependencyInfo   (DEPENDENCY& d ,CString DependencyName
                                 ,int& Icon ,int& NodeType ,BOOL& bHasChildren
                                 ,HTREEITEM Parent);

    CString     GetExtension    (int NodeType) const;

    CString     GetLocalFile    (int NodeType ,const CString ObjectName) const;

    void        EditTof         (int NodeType ,const CString ObjectName);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CXPROJECTTREE_H__06BCDA2D_DE1D_11D2_BCFC_00608CB45114__INCLUDED_)
