/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CXSourceTree.h
// -----------------
//
//    This is the include file for the CXSourceTree class
//
//=========================================================================



//{{AFX_INCLUDES()
#include "xtree.h"
//}}AFX_INCLUDES
#if !defined(AFX_CXSOURCETREE_H__E6F2D623_1CC2_11D3_BDF5_00A02456D506__INCLUDED_)
#define AFX_CXSOURCETREE_H__E6F2D623_1CC2_11D3_BDF5_00A02456D506__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CXSourceTree.h : header file
//
#include "CXUserMsg.h"
class CYRServer;
/////////////////////////////////////////////////////////////////////////////
// CXSourceTree dialog

class CXSourceTree : public CDialog
{
    // Construction
public:
    void EnableMenus(BOOL bEnabaled);
    void RefreshTree();
    CXSourceTree(BOOL bUseSCC, CWnd* pParent = NULL);   // standard constructor

    // @cmember Initialize server pointer for this class to use
    void SetServer(CYRServer* pServer);

    // @cmember Sets the project name for which the sources will be displayed
    void SetActiveProject(CString strProject);

    // @cmember Initializes the tree view
    void Activate();

    // Dialog Data
    //{{AFX_DATA(CXSourceTree)
    enum { IDD = IDD_SOURCE_TREE };
    CXTree  m_XSourceTree;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXSourceTree)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CXSourceTree)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnXTreeExpanding(long hTreeItem, short nNodeType, LPCTSTR szPath);
    afx_msg void OnLBDblClick(long hTreeItem, short nNodeType, LPCTSTR szPath);
    afx_msg void OnXTreeContextClick(LPCTSTR strPath, short nType, LPCTSTR strEntry);
    afx_msg void OnXTreeItemProperties(LPCTSTR strPath, short nType);
    afx_msg void OnXShowContext(short nNodeType, LPCTSTR strPath);
    DECLARE_EVENTSINK_MAP()
    //}}AFX_MSG
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    DECLARE_MESSAGE_MAP()

private:
    BOOL m_bUseSCC;
    BOOL IsFileLocked(short nNodeType, CString fileName);

    // @cmember Add the souces underneath the given parent item
    void AddSources(HTREEITEM parent);

    // @cmember Pointer to the active data server
    CYRServer* m_pServer;

    // @cmember Contains the active project
    CString m_strProject;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CXSOURCETREE_H__E6F2D623_1CC2_11D3_BDF5_00A02456D506__INCLUDED_)
