/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XServerErrorCtrl.h : Declaration of the CXServerErrorCtrl

#ifndef __XSERVERERRORCTRL_H_
#define __XSERVERERRORCTRL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CXServerErrorCtrl
class ATL_NO_VTABLE CXServerErrorCtrl :
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<IXServerErrorCtrl, &IID_IXServerErrorCtrl, &LIBID_XSERVERERRORLib>,
            public CComControl<CXServerErrorCtrl>,
            public IPersistStreamInitImpl<CXServerErrorCtrl>,
            public IOleControlImpl<CXServerErrorCtrl>,
            public IOleObjectImpl<CXServerErrorCtrl>,
            public IOleInPlaceActiveObjectImpl<CXServerErrorCtrl>,
            public IViewObjectExImpl<CXServerErrorCtrl>,
            public IOleInPlaceObjectWindowlessImpl<CXServerErrorCtrl>,
            public IPersistStorageImpl<CXServerErrorCtrl>,
            public ISpecifyPropertyPagesImpl<CXServerErrorCtrl>,
            public IQuickActivateImpl<CXServerErrorCtrl>,
            public IDataObjectImpl<CXServerErrorCtrl>,
            public IProvideClassInfo2Impl<&CLSID_XServerErrorCtrl, NULL, &LIBID_XSERVERERRORLib>,
            public CComCoClass<CXServerErrorCtrl, &CLSID_XServerErrorCtrl>
{
public:
    CXServerErrorCtrl()
    {}


    DECLARE_REGISTRY_RESOURCEID(IDR_XSERVERERRORCTRL)

    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(CXServerErrorCtrl)
    COM_INTERFACE_ENTRY(IXServerErrorCtrl)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(IViewObjectEx)
    COM_INTERFACE_ENTRY(IViewObject2)
    COM_INTERFACE_ENTRY(IViewObject)
    COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
    COM_INTERFACE_ENTRY(IOleInPlaceObject)
    COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
    COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
    COM_INTERFACE_ENTRY(IOleControl)
    COM_INTERFACE_ENTRY(IOleObject)
    COM_INTERFACE_ENTRY(IPersistStreamInit)
    COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
    COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
    COM_INTERFACE_ENTRY(IQuickActivate)
    COM_INTERFACE_ENTRY(IPersistStorage)
    COM_INTERFACE_ENTRY(IDataObject)
    COM_INTERFACE_ENTRY(IProvideClassInfo)
    COM_INTERFACE_ENTRY(IProvideClassInfo2)
    END_COM_MAP()

    BEGIN_PROP_MAP(CXServerErrorCtrl)
    PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
    PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
    // Example entries
    // PROP_ENTRY("Property Description", dispid, clsid)
    // PROP_PAGE(CLSID_StockColorPage)
    END_PROP_MAP()

    BEGIN_MSG_MAP(CXServerErrorCtrl)
    CHAIN_MSG_MAP(CComControl<CXServerErrorCtrl>)
    DEFAULT_REFLECTION_HANDLER()
    END_MSG_MAP()
    // Handler prototypes:
    //  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    //  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
    //  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



    // IViewObjectEx
    DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

    // IXServerErrorCtrl
public:
    STDMETHOD(Initialize)(LPCTSTR szProductName, LPCTSTR szErrorText);

    HRESULT OnDraw(ATL_DRAWINFO& di)
    {
        RECT& rc = *(RECT*)di.prcBounds;
        Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

        SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
        LPCTSTR pszText = _T("ATL 3.0 : XServerErrorCtrl");
        TextOut(di.hdcDraw,
                (rc.left + rc.right) / 2,
                (rc.top + rc.bottom) / 2,
                pszText,
                lstrlen(pszText));

        return S_OK;
    }
};

#endif //__XSERVERERRORCTRL_H_
