/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECRefreshDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xtestdynamicgraphs.h"
#include "CECRefreshDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECRefreshDlg dialog


CECRefreshDlg::CECRefreshDlg(int nRefresh, CWnd* pParent /*=NULL*/)
        : CDialog(CECRefreshDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CECRefreshDlg)
    m_Rate = _T("");
    //}}AFX_DATA_INIT

    m_nRefresh = nRefresh;
}


void CECRefreshDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECRefreshDlg)
    DDX_Control(pDX, IDC_SLIDER, m_Slider);
    DDX_Text(pDX, IDC_RATE, m_Rate);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECRefreshDlg, CDialog)
//{{AFX_MSG_MAP(CECRefreshDlg)
ON_WM_HSCROLL()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECRefreshDlg message handlers

BOOL CECRefreshDlg::OnInitDialog()
{
    CDialog::OnInitDialog();


    m_Slider.SetRange(500,60000);
    m_Slider.SetPos(m_nRefresh);
    m_Slider.SetTicFreq(1000);
    double d = (double)m_nRefresh;
    m_Rate.Format("%.1f Seconds",d/1000);
    UpdateData(FALSE);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CECRefreshDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
    if(pScrollBar)
    {
        UpdateData(TRUE);
        switch(pScrollBar->GetDlgCtrlID())
        {
        case IDC_SLIDER:
            {
                double d = (double)m_Slider.GetPos();
                m_Rate.Format("%.1f Seconds",d/1000);
            }
            break;
        }
        UpdateData(FALSE);
    }

    CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CECRefreshDlg::OnOK()
{
    m_nRefresh = m_Slider.GetPos();
    CDialog::OnOK();
}

int CECRefreshDlg::GetRefreshRate()
{
    return m_nRefresh;
}
