#if !defined(AFX_CECTESTGRAPHDLG_H__EA6B8D19_D24B_11D3_BD6F_00C04F89E392__INCLUDED_)
#define AFX_CECTESTGRAPHDLG_H__EA6B8D19_D24B_11D3_BD6F_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECTestGraphDlg.h : header file
//
#define __CLOSE_ON_EXCEPTIONS__ 1

#include "CORBA/CORBAServer.h"
#include "CORBAObjects\TestManager.h"
#include "CORBAObjects\TestLevel.h"
#include "CyrWrapLib\CECOrbServer.h"
#include "CyrWrapLib\CECOrbProject.h"
#include "CyrWrapLib\CECOrbFolder.h"

typedef enum {TESTINFO_TYPE, OTA_TYPE} INFO_TYPE;
typedef enum {PERFORMANCE, HISTORY};

class CXChartCtrl;

struct GRAPH_TYPE
{
    CXChartCtrl *pChart;
    INFO_TYPE nType;    // TESTINFO_TYPE or OTA_TYPE
    CString szName;     // e.g. "Active Threads" or "OTA - Users Waiting"
    int OTAIndex;       // index attached to an OTA data set
    CString OTANode;    // Node for this OTA data set
    int dataGroup;      // Data group of the graph control
    int graphIndex;     // Data group of the graph control
    int graphStyle;     // Performance or History
#if __CLOSE_ON_EXCEPTIONS__
    int nNumExceptions;
#endif
}
typedef GRAPH_TYPE;


/////////////////////////////////////////////////////////////////////////////
// CECTestGraphDlg dialog

class CECTestGraphDlg : public CDialog
{
    // Construction
public:
    void StartMonitor(CString strRegName,CString strInjector = "");
    CECTestGraphDlg(CWnd* pParent = NULL);   // standard constructor
    ~CECTestGraphDlg();
    CArray <GRAPH_TYPE, GRAPH_TYPE> m_availableTypes;
    CArray <GRAPH_TYPE, GRAPH_TYPE> m_selectedTypes;

    // Dialog Data
    //{{AFX_DATA(CECTestGraphDlg)
    enum { IDD = IDD_GRAPH_DLG };
    //}}AFX_DATA

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECTestGraphDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    afx_msg void OnContextMenu(CWnd*, CPoint point);
    // Generated message map functions
    //{{AFX_MSG(CECTestGraphDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnTimer(UINT nIDEvent);
    afx_msg void OnConfig();
    afx_msg void OnDestroy();
    afx_msg void OnPopupRefresh();
    afx_msg void OnPopupConfig();
    //}}AFX_MSG
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    DECLARE_MESSAGE_MAP()
private:
    int m_nRefreshRate;
    CXChartCtrl* CreateDisplay(const CRect& rcGraph);
    void AddGraphDisplay(GRAPH_TYPE &type);

    long m_nOTAHeaderIndex;
    long m_nOTADataIndex;
    void RollOTAGraphs();
    void RollActiveThreads(const GRAPH_TYPE& type);
    void SetupGraphs();
    void FindAvailableGraphTypes();
    CORBAServer* m_pCorbaClt;
    TestManager_var m_TM;
    TestLevel_var m_ActiveLevel;
    CyrStTestRun_var m_TestRun;
    int m_nNextGroup;
    int m_OTACount;
    CString m_strInjector;
    CString m_strManager;

#if __CLOSE_ON_EXCEPTIONS__
    void RemoveSelectedType(const GRAPH_TYPE &type);
#endif

    //  CArray <CXChartCtrl*,CXChartCtrl*> m_arGraphs;
}
;

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECTESTGRAPHDLG_H__EA6B8D19_D24B_11D3_BD6F_00C04F89E392__INCLUDED_)
