/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XTestDynamicGraphsCtl.cpp : Implementation of the CXTestDynamicGraphsCtrl ActiveX Control class.

#include "stdafx.h"
#include "XTestDynamicGraphs.h"
#include "XTestDynamicGraphsCtl.h"
#include "XTestDynamicGraphsPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CXTestDynamicGraphsCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CXTestDynamicGraphsCtrl, COleControl)
//{{AFX_MSG_MAP(CXTestDynamicGraphsCtrl)
ON_WM_CREATE()
ON_WM_SIZE()
ON_WM_DESTROY()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CXTestDynamicGraphsCtrl, COleControl)
//{{AFX_DISPATCH_MAP(CXTestDynamicGraphsCtrl)
DISP_FUNCTION(CXTestDynamicGraphsCtrl, "XInitialize", XInitialize, VT_EMPTY, VTS_BSTR VTS_BSTR)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CXTestDynamicGraphsCtrl, COleControl)
//{{AFX_EVENT_MAP(CXTestDynamicGraphsCtrl)
EVENT_CUSTOM("ControlClosing", FireControlClosing, VTS_NONE)
//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CXTestDynamicGraphsCtrl, 1)
PROPPAGEID(CXTestDynamicGraphsPropPage::guid)
END_PROPPAGEIDS(CXTestDynamicGraphsCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CXTestDynamicGraphsCtrl, "XTESTDYNAMICGRAPHS.XTestDynamicGraphsCtrl.1",
                       0xea6b8d08, 0xd24b, 0x11d3, 0xbd, 0x6f, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CXTestDynamicGraphsCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DXTestDynamicGraphs =
    {
        0xea6b8d06, 0xd24b, 0x11d3, { 0xbd, 0x6f, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };
const IID BASED_CODE IID_DXTestDynamicGraphsEvents =
    {
        0xea6b8d07, 0xd24b, 0x11d3, { 0xbd, 0x6f, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwXTestDynamicGraphsOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CXTestDynamicGraphsCtrl, IDS_XTESTDYNAMICGRAPHS, _dwXTestDynamicGraphsOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::CXTestDynamicGraphsCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CXTestDynamicGraphsCtrl

BOOL CXTestDynamicGraphsCtrl::CXTestDynamicGraphsCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // TODO: Verify that your control follows apartment-model threading rules.
    // Refer to MFC TechNote 64 for more information.
    // If your control does not conform to the apartment-model rules, then
    // you must modify the code below, changing the 6th parameter from
    // afxRegApartmentThreading to 0.

    if (bRegister)
        return AfxOleRegisterControlClass(
                   AfxGetInstanceHandle(),
                   m_clsid,
                   m_lpszProgID,
                   IDS_XTESTDYNAMICGRAPHS,
                   IDB_XTESTDYNAMICGRAPHS,
                   afxRegApartmentThreading,
                   _dwXTestDynamicGraphsOleMisc,
                   _tlid,
                   _wVerMajor,
                   _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::CXTestDynamicGraphsCtrl - Constructor

CXTestDynamicGraphsCtrl::CXTestDynamicGraphsCtrl()
{
    InitializeIIDs(&IID_DXTestDynamicGraphs, &IID_DXTestDynamicGraphsEvents);

    // TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::~CXTestDynamicGraphsCtrl - Destructor


CXTestDynamicGraphsCtrl::~CXTestDynamicGraphsCtrl()
{
    // TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::OnDraw - Drawing function


void CXTestDynamicGraphsCtrl::OnDraw(
    CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    // TODO: Replace the following code with your own drawing code.
    //  pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
    //  pdc->Ellipse(rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::DoPropExchange - Persistence support


void CXTestDynamicGraphsCtrl::DoPropExchange(CPropExchange* pPX)
{
    ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
    COleControl::DoPropExchange(pPX);

    // TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl::OnResetState - Reset control to default state


void CXTestDynamicGraphsCtrl::OnResetState()
{
    COleControl::OnResetState();  // Resets defaults found in DoPropExchange

    // TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl message handlers


int CXTestDynamicGraphsCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (COleControl::OnCreate(lpCreateStruct) == -1)
        return -1;

    //Create the dialog we're going to show
    m_TestGraphDlg.Create(IDD_GRAPH_DLG,this);

    //TODO: and tell it about the data to show

    return 0;
}

void CXTestDynamicGraphsCtrl::OnSize(UINT nType, int cx, int cy)
{
    COleControl::OnSize(nType, cx, cy);

    //resize the dialog to fit the window
    if(m_TestGraphDlg.GetSafeHwnd() != NULL)
    {
        m_TestGraphDlg.MoveWindow(0,0,cx,cy);
    }
}

BOOL CXTestDynamicGraphsCtrl::PreTranslateMessage(MSG* pMsg)
{
    if(m_TestGraphDlg.PreTranslateMessage(pMsg))
        return true;

    return COleControl::PreTranslateMessage(pMsg);
}

void CXTestDynamicGraphsCtrl::XInitialize(LPCTSTR strManagerRegName, LPCTSTR strInjector)
{
    if(strInjector==NULL)
        m_TestGraphDlg.StartMonitor(strManagerRegName,"");
    else
        m_TestGraphDlg.StartMonitor(strManagerRegName,strInjector);
}

void CXTestDynamicGraphsCtrl::OnDestroy()
{
    COleControl::OnDestroy();

    FireControlClosing();
}

BOOL CXTestDynamicGraphsCtrl::OnEraseBkgnd(CDC* pDC)
{
    return true;
    //  return COleControl::OnEraseBkgnd(pDC);
}
