#if !defined(AFX_XTESTMONCTL_H__6CF93B33_9051_11D3_9A95_00500447FC27__INCLUDED_)
#define AFX_XTESTMONCTL_H__6CF93B33_9051_11D3_9A95_00500447FC27__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#include "CECTestStatus.h"  // Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XTestMonCtl.h : Declaration of the CXTestMonCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CXTestMonCtrl : See XTestMonCtl.cpp for implementation.

class CXTestMonCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXTestMonCtrl)

    // Constructor
public:
    CXTestMonCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXTestMonCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXTestMonCtrl();

    DECLARE_OLECREATE_EX(CXTestMonCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXTestMonCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXTestMonCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXTestMonCtrl)       // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXTestMonCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnDestroy();
    //}}AFX_MSG
    afx_msg LRESULT OnUpdateActiveTest(WPARAM,LPARAM);
    afx_msg LRESULT OnShowDynGraph(WPARAM,LPARAM);
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXTestMonCtrl)
    afx_msg void XShowTestStatus(LPCTSTR strManagerName);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    // Event maps
    //{{AFX_EVENT(CXTestMonCtrl)
    void FireXUpdateActiveTestName(LPCTSTR strTestName)
    {
        FireEvent(eventidXUpdateActiveTestName,EVENT_PARAM(VTS_BSTR), strTestName);
    }
    void FireShowDynGraph(LPCTSTR strRegManager)
    {
        FireEvent(eventidShowDynGraph,EVENT_PARAM(VTS_BSTR), strRegManager);
    }
    void FireClosingControl()
    {
        FireEvent(eventidClosingControl,EVENT_PARAM(VTS_NONE));
    }
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXTestMonCtrl)
        dispidXShowTestStatus = 1L,
        eventidXUpdateActiveTestName = 1L,
        eventidShowDynGraph = 2L,
        eventidClosingControl = 3L,
        //}}AFX_DISP_ID
    };
private:
    int m_LevelColsActive;
    CECTestStatus m_TestStatus;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XTESTMONCTL_H__6CF93B33_9051_11D3_9A95_00500447FC27__INCLUDED)
