/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc CyrFFApi
///////////////////////////////////////////////////////////////////////////////

#ifndef _CECFFSCLFile_h
#define _CECFFSCLFile_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <CyrffApi/CECFFFile.h>

///////////////////////////////////////////////////////////////////////////////
// @class   CECFFSCLFile | This class represents an SCL source file.  The main
//          difference between this and a normal file is the Compile method.
// @base    public | CECFFFile
class CYR_EXPORT CECFFSCLFile : public CECFFFile
{
    // @access Public Members
public:
    // @cmember Constructor used to retrieve a File
    CECFFSCLFile( CECFFFolder* parent, const char* name );
    // @cmember Constructor used to create a new File
    CECFFSCLFile( CECFFFolder* parent, const char* name, const char* desc );

    bool Compile();  // @cmember Compile source file to object code

    // @access Protected Members
protected:
    string GetTOFName();  // @cmember Returns full name of the tof file
    string GetSCLName();  // @cmember Returns full name of the source file
    string BuildCommandLine();  // @cmember Constructs a command line entry
}
;

#endif
