/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     CyrThreadProvider
///////////////////////////////////////////////////////////////////////////////

#ifndef _CyrThreadProv_h
#define _CyrThreadProv_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <Factory/Provider_i.h>

///////////////////////////////////////////////////////////////////////////////
// @class   CyrThreadProvider | This Provider can create objects related to
//          starting threads and processes.
// @base    public | ProviderImpl
class CyrThreadProvider : public ProviderImpl
{
    // @access Public Members
public:
    // @cmember Constructor.
    CyrThreadProvider( CORBAServer* pServer, const char* name, const char* owner );

    // @cmember Method for creating objects via Factory.
    CORBA::Object_ptr New( ParamList_ptr params );
};

#endif
