/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc Registry
///////////////////////////////////////////////////////////////////////////////

#ifndef _Registry_i_h
#define _Registry_i_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <Objects/Registry.h>

///////////////////////////////////////////////////////////////////////////////
// @class   RegistryImpl | This class is the implementation of the CORBA class
//          Registry.  This class allows remote access via CORBA to a machine's
//          Windows registry.
// @base    public | _sk_Registry
class RegistryImpl : public virtual _sk_Registry
{
    // @access Public Members
public:
    RegistryImpl();
    virtual ~RegistryImpl();

    long  GetLongFromKey( const char* key );
    char* GetStringFromKey( const char* key );

    void SetLongFromKey( const char* key, long value );
    void SetStringFromKey( const char* key, const char* value );

private:
    HKEY m_hRegKey;     // @cmember Default registry entry
    void GetSubKeyValue( const char* key, unsigned char* buf, DWORD& length );
};

#endif
