#if !defined(AFX_FONTCOMBOEX_H__16D4CE88_EDFF_11D3_AC81_00105A483E3C__INCLUDED_)
#define AFX_FONTCOMBOEX_H__16D4CE88_EDFF_11D3_AC81_00105A483E3C__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FontComboEx.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFontComboEx window
typedef enum {FONTS} STYLE;      //Why have I enumerated, Cos, Maybe I might want something other than Fonts here

class CFontComboEx : public CComboBox
{
    // Construction
public:
    CFontComboEx();
    CFontComboEx(STYLE);
    // Attributes
public:
    void SetHilightColors (COLORREF hilight,COLORREF hilightText)
    {
        m_clrHilight = hilight;
        m_clrHilightText = hilightText;
    };
    void SetNormalColors (COLORREF clrBkgnd,COLORREF clrText)
    {
        m_clrNormalText = clrText;
        m_clrBkgnd = clrBkgnd;
    };
    static BOOL CALLBACK EnumFontProc (LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData);
    void FillFonts ();

    int  GetSelFont (LOGFONT&);
    void SetSelFont (LOGFONT *lf) ;
    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFontComboEx)
public:
    virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
    virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
protected:
    virtual void PreSubclassWindow();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CFontComboEx();

    // Generated message map functions
protected:
    STYLE m_enStyle;
    COLORREF m_clrHilight;
    COLORREF m_clrNormalText;
    COLORREF m_clrHilightText;
    COLORREF m_clrBkgnd;
    BOOL m_bInitOver;


    void DrawDefault (LPDRAWITEMSTRUCT);
    void DrawFont(LPDRAWITEMSTRUCT);

    void InitFonts ();
    //{{AFX_MSG(CFontComboEx)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnDestroy();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FONTCOMBOEX_H__16D4CE88_EDFF_11D3_AC81_00105A483E3C__INCLUDED_)
