/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CheckTreeCtrl.h: interface for the CCheckTreeCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHECKTREECTRL_H__12FBEA24_9007_11D2_ABFF_00105A483E3C__INCLUDED_)
#define AFX_CHECKTREECTRL_H__12FBEA24_9007_11D2_ABFF_00105A483E3C__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ExtendedTreeCtrl.h"

//-------------------------------------------------------------------------------

class CCheckTreeCtrl : public CExtendedTreeCtrl
{
    CImageList  m_cImageListState ;

public:
    CCheckTreeCtrl();
    virtual ~CCheckTreeCtrl();

    void InitStateImage() ;

    virtual BOOL InsertItem( HTREEITEM & hItem ,
                             LPCTSTR     lpszItem ,
                             int         nImage ,
                             int         nSelectedImage ,
                             DWORD       dwID ,
                             DWORD       dwParentID ) ;

    BOOL IsItemChecked( HTREEITEM hItem ) ;
    BOOL IsItemUnChecked( HTREEITEM hItem ) ;
    HTREEITEM GetFirstCheckedItem() ;
    HTREEITEM GetNextCheckedItem( HTREEITEM hItem ) ;
    HTREEITEM GetPreviousCheckedItem( HTREEITEM hItem ) ;

    void SetChildrenState( int iImage , HTREEITEM hParentItem ) ;

    BOOL IsImageStateSelected( CPoint pt ) ;
    void SetImageStateSelected( CPoint pt ) ;
    BOOL IsCollapse_Expand_Enable() ;

    virtual void DoOwnerContextMenu( CMenu * pSubMenu ) ;

    void SetCheck( HTREEITEM hItem ) ;
    void UnCheck( HTREEITEM hItem ) ;
    void SetCheckThreeState( HTREEITEM hItem ) ;

    BOOL IsBrotherStateUncheck( HTREEITEM hBrotherItem ) ;
    BOOL IsBrotherStateChecked( HTREEITEM hBrotherItem ) ;
    BOOL IsAllBrothersChecked( HTREEITEM hBrotherItem ) ;
    BOOL HasBrothers( HTREEITEM hItem ) ;

    virtual void SetParentState( int iImage , HTREEITEM hItem ) ;

    void UnCheckAll( HTREEITEM hItem ) ;



protected:
    //{{AFX_MSG(CCheckTreeCtrl)
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnKeyDown( UINT nChar , UINT nRepCnt, UINT nFlags ) ;
    afx_msg void OnUpdateSelectItem(CCmdUI* pCmdUI) ;
    afx_msg void OnUpdateUnSelectItem(CCmdUI* pCmdUI) ;
    afx_msg void OnSelectItem() ;
    afx_msg void OnUnSelectItem() ;
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

};

#endif // !defined(AFX_CHECKTREECTRL_H__12FBEA24_9007_11D2_ABFF_00105A483E3C__INCLUDED_)
