#if !defined(AFX_EXTENDEDRICHEDITCTRL_H__58C997C4_38D5_11D2_9205_00104B4B2995__INCLUDED_)
#define AFX_EXTENDEDRICHEDITCTRL_H__58C997C4_38D5_11D2_9205_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ExtendedRichEditCtrl.h : header file
//
struct EditStreamOutStruct
{
    CString* m_pString;
    LONG m_lOffset;
};

struct EditStreamInStruct
{
    LPCSTR m_psz;
    LONG m_lLength;
    LONG m_lOffset;
};

struct CCharFormat : public CHARFORMAT
{
    CCharFormat()
    {
        cbSize = sizeof(CHARFORMAT);
    }
    BOOL operator==(CCharFormat& cf);
};


/////////////////////////////////////////////////////////////////////////////
// CExtendedRichEditCtrl window
/////////////////////////////////////////////////////////////////////////////
class CExtendedRichEditCtrl : public CRichEditCtrl
{
    // Attributes
private:
    BOOL    m_bGray;
    BOOL    m_bAsAControl;

    // Construction
public:
    CExtendedRichEditCtrl();
    virtual ~CExtendedRichEditCtrl();

    // Operations
public:

    void        SetGrayBackGround();
    void        SetAsAControl(BOOL _bAsAControl);

    void        UpdateState(CMenu *_pMenu, UINT _nId);
    void        SetRTFText(LPCSTR szRTF);
    CString     GetRTFText( CString &sRTFResult ) ;

    // Generated message map functions
protected:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CExtendedRichEditCtrl)
protected:
    virtual void PreSubclassWindow();
    //}}AFX_VIRTUAL

    //{{AFX_MSG(CExtendedRichEditCtrl)
    // NOTE - the ClassWizard will add and remove member functions here.
    afx_msg void OnContextMenu( CWnd* pWnd, CPoint pos );
    afx_msg void OnRButtonDown( UINT nFlags, CPoint point );
    afx_msg void OnUnDo();
    afx_msg void OnCut();
    afx_msg void OnCopy();
    afx_msg void OnPaste();
    afx_msg void OnFormat();
    //}}AFX_MSG

    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXTENDEDRICHEDITCTRL_H__58C997C4_38D5_11D2_9205_00104B4B2995__INCLUDED_)
