#if !defined(AFX_STUBDOCUMENT_H__1F8145B3_6182_11D1_9E26_0020AFAC7193__INCLUDED_)
#define AFX_STUBDOCUMENT_H__1F8145B3_6182_11D1_9E26_0020AFAC7193__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/



#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// StubDocument.h : header file
//

class CRootDocument;

/////////////////////////////////////////////////////////////////////////////
// CStubDocument document
/////////////////////////////////////////////////////////////////////////////
//
// CStubDocument a pour vocation de servir d'interface et de lien entre le
// pseuso-document associ aux diffrentes frames spcialises et le document
// MFC proprement dit.
/////////////////////////////////////////////////////////////////////////////


class CStubDocument : public CDocument
{
    CRootDocument* m_pRootDocument ;
    int            m_nOwnershipCount ;
    WORD           m_wStatus ;

protected:
    CStubDocument();           // protected constructor used by dynamic creation
    DECLARE_DYNCREATE(CStubDocument)

    // Attributes
public:

    struct CommandInfo
    {
        CCmdUI * m_pCmdUI ;       // >>> Ignore all the rest if != NULL <<<
        CWnd   * m_pParentFrame ; // Parent frame of the sender (usually a control)
        CWnd   * m_pSender ;      // Command sender (usually a control)
        UINT     m_nSenderID ;    // Command sender Ctrl ID
        UINT     m_nCommandID ;   // Command ID (e.g menuitem)
        void   * pUserData ;
        //
        CommandInfo() ; // memset(0)
    }
    ;

    enum Status
    {
        stsIsGenOwner = 0x0001 ,
        stsNoAutoTitle = 0x0002    //SC : 05/02/98
    } ;

    // Operations
public:
    BOOL GetStatus( Status status ) const ;
protected:
    void SetStatus( Status status , BOOL bSet = TRUE ) ;
public:

    void IncrOwnershipCount() ;
    void DecrOwnershipCount() ;

    BOOL GetAutoTitle() const ;
    void SetAutoTitle( BOOL bSetON ) ;
    BOOL SetWindowTitle( int nID , int nCount ) const  ;
    BOOL SetWindowTitle( int nID , int nCount1 , int nCount2 ) const ;
    BOOL SetWindowTitle( int nID , CString &strName ) const ;
    BOOL IsGenDocOwner() const ; // Owns a CGenDoc-derived document

    BOOL DoGenDocRefresh( UINT nCommand , BOOL bPostCommand = FALSE ) ;

    // TRUE if 'pWnd' is either a view associated with this document or a child thereof
    BOOL IsDocWindow( const CWnd * pWnd ) const ;

    void             SetRootDocument( CRootDocument * pDoc ) ; // Call only once otherwise ASSERT !
    CRootDocument*   GetRootDocument() const ;

    // SetTitle : Utiliser le mme ID pour le CDocTemplate et la ressouce String
    BOOL SetTitle( UINT nTitleResStringID ) ;

    // Command handlers. (Ovverrides must return TRUE if handled)
    /*$$$JLvirtual BOOL OnCmdSort( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdFilter( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdSearch( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdPrint( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdSaveRowsAs( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdRefs( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdScript( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdAncestor( CommandInfo * pInfo ) ;
    virtual BOOL OnCmdImpact( CommandInfo * pInfo ) ;*/

protected:
    BOOL DefaultCmdHandler( CommandInfo * pInfo ) ;
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CStubDocument)
public:
    virtual void Serialize(CArchive& ar);   // overridden for document i/o
    virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
    virtual void OnCloseDocument();
protected:
    virtual BOOL OnNewDocument();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CStubDocument();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CStubDocument)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

// --------------------------------------------------------------------------

#endif // !defined(AFX_STUBDOCUMENT_H__1F8145B3_6182_11D1_9E26_0020AFAC7193__INCLUDED_)
