/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef __GATEWAYINSTANCE__
#define __GATEWAYINSTANCE__

class CGatewayInstance
{
public:
CGatewayInstance(port_t adminPort):adminPort_(adminPort),iInstanceNumber_(0)
    {}


    void increase()
    {
        iInstanceNumber_ ++ ;
    }
    void decrease()
    {
        iInstanceNumber_ -- ;
    }

    int getIntanceNumber() const
    {
        return iInstanceNumber_ ;
    }

    bool                operator == (const CGatewayInstance& gInstance) const
    {
        return gInstance.adminPort_ == adminPort_;
    }
    bool                operator < (const CGatewayInstance& gInstance) const
    {
        return gInstance.adminPort_ < adminPort_;
    }

private:
    port_t      adminPort_ ;
    int         iInstanceNumber_ ;
};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////// Class CGatewayInstanceList //
///////////////////////////////////////////////////////////////////////////////
class CGatewayInstanceList  : public CTMonitor<CTMutex>
{
    typedef list<CGatewayInstance *> CGatewayInstanceStlList ;
    //-----------------------------------------------------------------------------
public:                     // Constructor(s) and destructor.
    CGatewayInstanceList ()
    {}

    ~CGatewayInstanceList ()
    {
        reset() ;
    }

    //-----------------------------------------------------------------------------
public:                     // Control methodes.
    void                    add (CGatewayInstance* gInstance) ;
    void                    remove (CGatewayInstance* gInstance) ;
    CGatewayInstance*       find (CGatewayInstance* gInstance) ;
    unsigned int            entries (void)
    {
        return list_.size ();
    }
    void                    reset () ;
    //-----------------------------------------------------------------------------
public:                     // Get* methodes.
    const CGatewayInstanceStlList&  getList (void) const
    {
        return list_ ;
    }

    //-----------------------------------------------------------------------------
private:                    // Members.
    CGatewayInstanceStlList list_ ;

    //-----------------------------------------------------------------------------
}

; // CGatewayInstanceList

#endif
