/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ServerHeaderView.cpp: implementation of the CServerHeaderView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "modeller.h"
#include "ModellerDoc.h"
#include "constantes.h"
#include "VarAddrNameDlg.h"
#include "VariousObject.h"
#include "ServerHeaderView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//----------------------------------------------------------------------------

IMPLEMENT_DYNCREATE(CServerHeaderView, CHeaderView)

//----------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CServerHeaderView, CHeaderView)
//{{AFX_MSG_MAP(CServerHeaderView)
ON_UPDATE_COMMAND_UI(IDM_ADDRESS, OnUpdateAddressing)
ON_COMMAND(IDM_ADDRESS, OnAddressing)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//----------------------------------------------------------------------------

CServerHeaderView::CServerHeaderView()
{
}

//----------------------------------------------------------------------------


CServerHeaderView::~CServerHeaderView()
{
}

//----------------------------------------------------------------------------


void CServerHeaderView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
    if( lHint == ID_DISPLAY_SERVERHEADER_URL )
    {
        FillGrid(((CStringObject*)pHint)->m_strObject) ;
    }
    else
        CHeaderView::OnUpdate(pSender, lHint, NULL);

}

//----------------------------------------------------------------------------

void CServerHeaderView::DoOwnerContextMenu( CMenu * pSubMenu )
{
    //pSubMenu->AppendMenu( MF_SEPARATOR ) ;  //OS
    pSubMenu->AppendMenu( MF_STRING , IDM_ADDRESS , _T("Address" ) ) ;

}

//----------------------------------------------------------------------------

void CServerHeaderView::OnUpdateAddressing(CCmdUI* pCmdUI)
{
    int      nRow ;
    BOOL        bEnable ;
    //---
    bEnable = TRUE ;
    if ( !m_wndGrid.GetFirstSelectedRow( nRow ) ) //OS
        bEnable = FALSE;
    if ( ( nRow > m_wndGrid.GetLastDataRow() ) || ( nRow <= 0 ))
        bEnable = FALSE;

    pCmdUI->Enable( bEnable );
}

//----------------------------------------------------------------------------

void CServerHeaderView::OnAddressing()
{
    int             nRow ;
    //int               nCol ;
    CVarResponse    VarResponse ;
    CModellerDoc *  pDoc ;
    int             nRet;

    CVarAddrNameDlg Dlg( &VarResponse ) ;
    //---
    if( Dlg.DoModal() == IDCANCEL )
        return;

    nRet = m_wndGrid.GetFirstSelectedRow( nRow ) ;  //OS
    ASSERT( nRet) ;

    m_wndGrid.GetValueRowCol( nRow, COL_HEADER_NAME, VarResponse.m_strIdentifier ) ;  //OS
    VarResponse.m_ResponseType = RT_HEADER ;

    pDoc = static_cast<CModellerDoc *>(GetDocument());
    pDoc->Adressing( &VarResponse ) ;

}

