/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECDefaultCodeWriter.h
// ----------------------
//
//    This is the include file for the CECDefaultCodeWriter class
//
//=========================================================================

#ifndef CECDefaultCodeWriter_Loaded
#define CECDefaultCodeWriter_Loaded

class CECDefaultCodeWriter : public CObject
{
    // Construction
public:
    CECDefaultCodeWriter    ();
    ~CECDefaultCodeWriter();

    enum SECTION    {SCL_HEADER, SCL_ENVIRONMENT, SCL_DEFINITIONS, SCL_CODE, SCL_EXIT,
                     TSS_HEADER, TSS_ENVIRONMENT, TSS_DEFINITIONS, TSS_CODE, TSS_EXIT,
                     THS_HEADER, THS_ENVIRONMENT, THS_DEFINITIONS, THS_CODE, THS_EXIT};

    virtual CString GetDefaultText(SECTION nType, CString szFileName = "");

    CString GetDefaultHeaderText(CString szFileName);
    CString GetDefaultEnvironmentText();
    CString GetDefaultDefinitionText();
    CString GetDefaultCodeText();
    CString GetDefaultExitText();

    CString GetSectionTitle(SECTION nType);

    BOOL DoesTemplateExist(SECTION nType);
    CString UseTemplate(SECTION nType);
    CString GetTemplateFileName(SECTION nType);
    void StripOffTrailingSlash(CString& szPath);
    void GenerateDefaultOtaTof(const CString& strOTAFile,const CString& strPhysicalNode);
};
#endif
