/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECSclWriter.h
// --------------
//
//    This is the include file for the CECSclWriter class
//
//=========================================================================

#ifndef CECSclWriter_Loaded
#define CECSclWriter_Loaded

#include "CECDefaultCodeWriter.h"

class CECSclWriter : public CECDefaultCodeWriter
{
    // Construction
public:
    CECSclWriter    ();
    ~CECSclWriter();

    enum SCL_SECTION {  HEADER = SCL_HEADER,
                        ENVIRONMENT = SCL_ENVIRONMENT,
                        DEFINITIONS = SCL_DEFINITIONS,
                        CODE = SCL_CODE,
                        EXIT = SCL_EXIT};

    enum AUXILLARY_SCRIPT {CONNECT, DISCONNECT};
    enum LOOP_MODE  {DO, ENDDO};

    CString GetTemplateText(SCL_SECTION nType, CString szFileName = "");
    CString GetSectionTitle(SCL_SECTION nType);

    CString GetNameDefinitionText(SCL_SECTION nType, CString szDescription = "");
    CString GetScriptDependencyText(SCL_SECTION nType, CString szScriptName = "", int nPercent = 0, int nDependencyIndex =0, int nTotalDependencyCount = 0);
    CString GetDurationText(SCL_SECTION nType, BOOL bSpecifyAtRuntime = FALSE, LOOP_MODE nMode = ENDDO, int nIterations = 0);
    CString GetAuxillaryScriptText(SCL_SECTION nType, AUXILLARY_SCRIPT = CONNECT, CString szScriptName = "");
    CString GetSetupDurationText();
};
#endif
