/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// cecsourcefileutils.h: interface for the CECSourceFileUtils class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECSOURCEFILEUTILS_H__E06D8221_823F_11D3_9A95_00500447FC27__INCLUDED_)
#define AFX_CECSOURCEFILEUTILS_H__E06D8221_823F_11D3_9A95_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <afxtempl.h>

struct DEPENDENCY
{
    CString file;
    int type;
    int subType;
    int SrcType;
}
typedef DEPENDENCY;

class CYRServer;

class CECSourceFileUtils
{
public:
    CECSourceFileUtils(CYRServer *pServer,CString strLocalPath);
    virtual ~CECSourceFileUtils();

    enum{NONE, TSS, THREAD, SCL, FILE, INCL, IMG, EXE_SCL};

    BOOL Compile(bool bClearOutputWnd = true, bool bCompileDependencies = false);
    int ReadDependencies();
    DEPENDENCY GetDependency(int index);

private:
    CString m_strTOFPath;
    CString m_strDepName;
    BOOL CheckInTOF();
    BOOL CheckOutTOF();
    BOOL CheckOutDepFile();
    BOOL CheckInDepFile();
    BOOL CompileDependencies();
    CArray <DEPENDENCY, DEPENDENCY> m_Dependencies;
    int GetNextField(char sep, CString &inStr, CString &field);
    CString GetWorkDir();
    CString GetProjectName();
    CString m_strTOFName;
    BOOL IsCompiled();
    void BuildTOFName();
    CString GetCompilerPath();
    CString BuildCommandLine();
    CString m_strLocalPath;

    BOOL ExecuteCommand(CString cmd);
    BOOL InvokeImage    (CString command);
    CString m_strOutput;
    void ReadFromChild  ();
    void AddDependancyExtension(DEPENDENCY& dep);
    BOOL NeedsCompile();

    HANDLE      m_hChildStdoutRd;
    HANDLE      m_hChildStdoutWr;
    HANDLE      m_hChildStdinRd;
    CYRServer *m_pServer;
};

#endif // !defined(AFX_CECSOURCEFILEUTILS_H__E06D8221_823F_11D3_9A95_00500447FC27__INCLUDED_)
