/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECStyleFinder.h
// -----------------
//
//    This is the include file for the CECStyleFinder class
//
//=========================================================================


#if !defined(AFX_CECStyleFinder_H__97F10279_F959_11D2_8A98_0060084D8878__INCLUDED_)
#define AFX_CECStyleFinder_H__97F10279_F959_11D2_8A98_0060084D8878__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CECStyleFinder
{
public:
    BOOL HasContext (DWORD dwStyles);
    CECStyleFinder();
    virtual ~CECStyleFinder();

    // See if the CYR_IS_SUBPRODUCT style is set
    BOOL IsSubProduct(DWORD dwStyles);

    // See if the CYR_HAS_PROJECT style is set
    BOOL HasProject(DWORD dwStyles);

    // See if the CYR_HAS_SERVER style is set
    BOOL HasServer(DWORD dwStyles);

    // See if the CYR_NEEDS_SEPARATOR style is set
    BOOL NeedsSeparator(DWORD dwStyles);

    // See if the CYR_IS_REMOVEABLE style is set
    BOOL IsRemoveable(DWORD dwStyles);

    //see if the CYR_EXTENDED_UI_UPDATE style is set
    BOOL HasExtendedUIUpdate(DWORD dwStyles);

    // See if the CYR_NEEDS_SERVER style is set
    BOOL NeedsServer(DWORD dwStyles);

    // See if the CYR_NEEDS_PROJECT style is set
    BOOL NeedsProject(DWORD dwStyles);

    // See if the CYR_EDITABLE_DOCUMENT style is set
    BOOL IsEditable(DWORD dwStyles);

    // See if the CYR_HAS_TEMPLATE style is set
    BOOL HasTemplate(DWORD dwStyles);
};

#endif // !defined(AFX_CECStyleFinder_H__97F10279_F959_11D2_8A98_0060084D8878__INCLUDED_)
