/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECAuditLogger.h: interface for the CECAuditLogger class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECAUDITLOGGER_H__D0B912D7_361E_11D4_A6CE_00500447FC27__INCLUDED_)
#define AFX_CECAUDITLOGGER_H__D0B912D7_361E_11D4_A6CE_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "CORBA/CORBAServer.h"
#include "CORBAObjects\TestManager.h"
#include "CyrWrapLib\CECOrbServer.h"


struct _THREAD_MAP
{
    CString strRegName;
    CWinThread *m_pThread;
}
typedef _THREAD_MAP;


class CECAuditLogger
{
public:
    void StopLogging(CString strRegName);
    void StartLogging(CString strRegName);
    CECAuditLogger();
    virtual ~CECAuditLogger();
    CyrStTestRun_var m_TestRun;
    CString m_szTestName;

private:
    CORBAServer* m_pCorbaSrv;
    CArray<_THREAD_MAP, _THREAD_MAP> m_ThreadArray;
    static UINT LoggerThread(LPVOID pParam);

};

#endif // !defined(AFX_CECAUDITLOGGER_H__D0B912D7_361E_11D4_A6CE_00500447FC27__INCLUDED_)
