/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECDynTestGraphs.cpp : implementation file
//

#include "stdafx.h"
#include "CECDynTestGraphs.h"
#include "..\..\common\CECClipboard.h"
#include "Winsock2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECDynTestGraphs

IMPLEMENT_DYNCREATE(CECDynTestGraphs, CFormView)

CECDynTestGraphs::CECDynTestGraphs()
        : CFormView(CECDynTestGraphs::IDD)
{
    //{{AFX_DATA_INIT(CECDynTestGraphs)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


CECDynTestGraphs::~CECDynTestGraphs()
{}


void CECDynTestGraphs::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECDynTestGraphs)
    DDX_Control(pDX, IDC_XTESTDYNAMICGRAPHSCTRL, m_DynGraph);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECDynTestGraphs, CFormView)
//{{AFX_MSG_MAP(CECDynTestGraphs)
ON_WM_SIZE()
//}}AFX_MSG_MAP
ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECDynTestGraphs diagnostics

#ifdef _DEBUG
void CECDynTestGraphs::AssertValid() const
{
    CFormView::AssertValid();
}

void CECDynTestGraphs::Dump(CDumpContext& dc) const
{
    CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CECDynTestGraphs message handlers

void CECDynTestGraphs::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();

    CECClipboard cb;
    CString testRegName = cb.GetClipboardText();
    char *pszManager = strtok(testRegName.GetBuffer(0),"|");
    char *pszInjector = strtok(NULL,"|");

    m_DynGraph.XInitialize(pszManager,pszInjector);

    // set up the title which can be either ota specific of test specific
    if (pszInjector == NULL)
    {
        // Must be for Virtual Users ...
        GetDocument()->SetTitle("Virtual Users");
    }
    else
    {
        // Must be for OTA ...
        CString strIP = pszInjector;
        GetDocument()->SetTitle("Performance Statistics - "+GetComputerNameFromIP(strIP));
    }

    CRect r;
    GetClientRect(r);
    m_DynGraph.SetWindowPos(NULL, 0,0,r.Width(),r.Height(),SWP_NOZORDER);

    SIZE sz= {0};
    SetScrollSizes(MM_TEXT,sz);
}

void CECDynTestGraphs::OnSize(UINT nType, int cx, int cy)
{
    CFormView::OnSize(nType, cx, cy);

    if (m_DynGraph.m_hWnd != NULL)
    {
        m_DynGraph.SetWindowPos(NULL, 0,0,cx,cy,SWP_NOZORDER);
    }

}

BEGIN_EVENTSINK_MAP(CECDynTestGraphs, CFormView)
//{{AFX_EVENTSINK_MAP(CECDynTestGraphs)
ON_EVENT(CECDynTestGraphs, IDC_XTESTDYNAMICGRAPHSCTRL, 1 /* ControlClosing */, OnControlClosingXtestdynamicgraphsctrl, VTS_NONE)
//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CECDynTestGraphs::OnControlClosingXtestdynamicgraphsctrl()
{
    GetParentFrame()->DestroyWindow();
}

CString CECDynTestGraphs::GetComputerNameFromIP(const CString& strIP)
{
    CString strName;

    CString strIPCopy(strIP);
    strIPCopy.Replace('_','.');
    DWORD dwAddr = inet_addr(strIPCopy);

    HOSTENT *pHost = gethostbyaddr((char*)&dwAddr,4,AF_INET);
    if(pHost==NULL)
    {
        TRACE("Net error %d\n",WSAGetLastError());
        strName = strIP;
    }
    else
    {
        strName = pHost->h_name;
        strName = strName.SpanExcluding(".");
        strName.MakeUpper();
    }
    return strName;
}

BOOL CECDynTestGraphs::OnEraseBkgnd(CDC *pDC)
{
    return true;
}
