/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//{{AFX_INCLUDES()
#include "cecxtestinitwrapper.h"
//}}AFX_INCLUDES
#if !defined(AFX_CECEXECUTETESTDLG_H__6DFB3D36_FBD4_11D2_BDC7_00608CB45114__INCLUDED_)
#define AFX_CECEXECUTETESTDLG_H__6DFB3D36_FBD4_11D2_BDC7_00608CB45114__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECExecuteTestDlg.h : header file
//
#include "..\..\..\TProcLib\TestInitiator.h"
#include "resource.h"
class CYRServer;
/////////////////////////////////////////////////////////////////////////////
// CECExecuteTestDlg dialog


class CECExecuteTestDlg : public CDialog
{
    // Construction
public:
    void SetExecuted(BOOL bExecuted);
    void GetListOfTests();
    void GetListOfNodes();
    void SetExecuteInfo(CString ProjectName, CString TestName);
    void SetServerInfo(CString Host, CString Username, CString Password);

    BOOL IsExecuted();
    CECExecuteTestDlg(CWnd* pParent = NULL);   // standard constructor


    CString m_szNodeFile;
    CString m_szProjectName;
    CString m_szTestName;
    BOOL m_bExecuted;
    BOOL GetNodeInfo(CString& physNode, CString& userName, CString& password);

    // Dialog Data
    //{{AFX_DATA(CECExecuteTestDlg)
    enum { IDD = IDD_EXECUTE_TEST };
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECExecuteTestDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CECExecuteTestDlg)
    virtual BOOL OnInitDialog();
    virtual void OnOK();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    virtual void OnCancel();
    afx_msg void OnTimer(UINT nIDEvent);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
private:

    BOOL HasSpawnProc();

    CString m_szHost;
    CString m_szUsername;
    CString m_szPassword;
    CYRServer*  m_pServer;
    CWinThread *m_pThread;
    BOOL m_bExecuting;

    static void processException(const CString& rwError, CString& szDisplayText);
    static UINT execute(LPVOID pParam);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECEXECUTETESTDLG_H__6DFB3D36_FBD4_11D2_BDC7_00608CB45114__INCLUDED_)
