/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECLoggingView.cpp : implementation file
//

#include "stdafx.h"
#include "CECLoggingView.h"
#include "..\..\Interfaces\CyrPlugins.h"
#include "server.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECLoggingView

IMPLEMENT_DYNCREATE(CECLoggingView, CFormView)

CECLoggingView::CECLoggingView()
        : CFormView(CECLoggingView::IDD)
{
    //{{AFX_DATA_INIT(CECLoggingView)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


CECLoggingView::~CECLoggingView()
{}


void CECLoggingView::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECLoggingView)
    DDX_Control(pDX, IDC_XDIAGNOSERCTRL, m_XDiagnose);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECLoggingView, CFormView)
//{{AFX_MSG_MAP(CECLoggingView)
ON_WM_SIZE()
//}}AFX_MSG_MAP
ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECLoggingView diagnostics

#ifdef _DEBUG
void CECLoggingView::AssertValid() const
{
    CFormView::AssertValid();
}

void CECLoggingView::Dump(CDumpContext& dc) const
{
    CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CECLoggingView message handlers

void CECLoggingView::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();

    GetDocument()->SetTitle("System Tracing");

    // Get a handle to the Mainframe
    CWnd* pMainWnd = AfxGetMainWnd();
    ASSERT (pMainWnd != NULL);


    // Now get the server login information from the framework
    CYRServer *pServer = (CYRServer *)AfxGetMainWnd()->SendMessage (WMU_GET_SERVERPTR);
    CString szUser = pServer->GetUserName();
    CString szPass = pServer->GetPassword();

    //
    // And also get the project name.
    //
    CString ProjName = pServer->GetOpenProjectName();

    //
    // Now we have all the information we need we can initialize the control
    //
    m_XDiagnose.XSetServerInfo(szUser, szPass);
    m_XDiagnose.XSetActiveProject(ProjName);

    CRect r;
    GetClientRect(r);

    OnSize(NULL, r.Width(), r.Height());
}

void CECLoggingView::OnSize(UINT nType, int cx, int cy)
{
    CFormView::OnSize(nType, cx, cy);

    if (m_XDiagnose.m_hWnd != NULL)
    {
        m_XDiagnose.SetWindowPos(NULL, 0,0,cx,cy,SWP_NOZORDER);
    }
}

BOOL CECLoggingView::PreCreateWindow(CREATESTRUCT& cs)
{
    cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);
    return CFormView::PreCreateWindow(cs);
}

BOOL CECLoggingView::OnEraseBkgnd(CDC *pDC)
{
    return true;
}
