/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECMonitorView.cpp : implementation file
//

#include "stdafx.h"
#include "CECMonitorView.h"
#include "..\..\Interfaces\CyrPlugins.h"
#include "Solutions.h"

#include "CECAuditLogger.h"
extern CECAuditLogger* pAuditLogger;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECMonitorView

IMPLEMENT_DYNCREATE(CECMonitorView, CFormView)

CECMonitorView::CECMonitorView()
        : CFormView(CECMonitorView::IDD)
{
    //{{AFX_DATA_INIT(CECMonitorView)
    //}}AFX_DATA_INIT
}


CECMonitorView::~CECMonitorView()
{}


void CECMonitorView::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECMonitorView)
    DDX_Control(pDX, IDC_XMANAGERMONCTRL, m_XManagerMon);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECMonitorView, CFormView)
//{{AFX_MSG_MAP(CECMonitorView)
ON_WM_SIZE()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECMonitorView diagnostics

#ifdef _DEBUG
void CECMonitorView::AssertValid() const
{
    CFormView::AssertValid();
}

void CECMonitorView::Dump(CDumpContext& dc) const
{
    CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CECMonitorView message handlers

BEGIN_EVENTSINK_MAP(CECMonitorView, CFormView)
//{{AFX_EVENTSINK_MAP(CECMonitorView)
ON_EVENT(CECMonitorView, IDC_XMANAGERMONCTRL, 1 /* ShowManagerDetails */, OnShowManagerDetails, VTS_BSTR)
ON_EVENT(CECMonitorView, IDC_XMANAGERMONCTRL, 2 /* ShowInjectorView */, OnShowInjectorViewXmanagermonctrl, VTS_BSTR)
ON_EVENT(CECMonitorView, IDC_XMANAGERMONCTRL, 3 /* ClosingControl */, OnClosingControlXmanagermonctrl, VTS_NONE)
ON_EVENT(CECMonitorView, IDC_XMANAGERMONCTRL, 4 /* LogAudit */, OnLogAudit, VTS_BSTR VTS_I2)
//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CECMonitorView::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();

    // Make the window the size of the main dialog

    GetDocument()->SetTitle("Active Tests");
    GetParentFrame()->RecalcLayout();

    //  ResizeParentToFit(FALSE);

    CRect r;
    GetClientRect(r);
    m_XManagerMon.SetWindowPos(NULL, 0,0,r.Width(),r.Height(),SWP_NOZORDER);

    SIZE sz= {0};
    SetScrollSizes(MM_TEXT,sz);
}

void CECMonitorView::OnSize(UINT nType, int cx, int cy)
{
    /*  if (cx<300 || cy<300)
        {
            CFormView::OnSize(nType, cx, cy);
     
            return;
        }
    */
    CFormView::OnSize(nType, cx, cy);

    if (m_XManagerMon.m_hWnd != NULL)
    {
        m_XManagerMon.SetWindowPos(NULL, 0,0,cx,cy,SWP_NOZORDER);
    }
}

BOOL CECMonitorView::PreCreateWindow(CREATESTRUCT& cs)
{
    // Make sure that we don't create anything too small
    if (cs.cx < FRAMEMINWIDTH) cs.cx = FRAMEMINWIDTH;
    if (cs.cy < FRAMEMINDEPTH) cs.cy = FRAMEMINDEPTH;

    return CFormView::PreCreateWindow(cs);
}

void CECMonitorView::OnShowManagerDetails(LPCTSTR strRegName)
{
    CWnd* pMainWnd = AfxGetMainWnd();

    CString monitorInfo;
    monitorInfo.Format("%s|%s" ,SOLUTIONS_GENERIC_DLL ,strRegName);

    pMainWnd->SendMessage (WMU_FIRE_SPECIFIC_EVENT
                           ,(WPARAM )WMU_LEVEL_MONITOR
                           ,(LPARAM) &monitorInfo);

}

void CECMonitorView::OnShowInjectorViewXmanagermonctrl(LPCTSTR strRegName)
{
    CWnd* pMainWnd = AfxGetMainWnd();

    CString monitorInfo;
    monitorInfo.Format("%s|%s" ,SOLUTIONS_GENERIC_DLL ,strRegName);

    pMainWnd->SendMessage (WMU_FIRE_SPECIFIC_EVENT
                           ,(WPARAM )WMU_INJECTOR_VIEW
                           ,(LPARAM) &monitorInfo);
}

BOOL CECMonitorView::OnEraseBkgnd(CDC *pDC)
{
    return true;
}

void CECMonitorView::OnClosingControlXmanagermonctrl()
{
    GetParentFrame()->DestroyWindow();
}

void CECMonitorView::OnLogAudit(LPCTSTR strRegName, short nState)
{
    if (nState == 1)
    {
        pAuditLogger->StartLogging(strRegName);
    }
    else
    {
        pAuditLogger->StopLogging(strRegName);
    }
}
