/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECTestLevelMonitor.cpp : implementation file
//

#include "stdafx.h"
#include "CECTestLevelMonitor.h"
#include "..\..\common\CECClipboard.h"
#include "..\..\interfaces\cyrplugins.h"
#include "..\..\..\include\solutions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECTestLevelMonitor

IMPLEMENT_DYNCREATE(CECTestLevelMonitor, CFormView)

CECTestLevelMonitor::CECTestLevelMonitor()
        : CFormView(CECTestLevelMonitor::IDD)
{
    //{{AFX_DATA_INIT(CECTestLevelMonitor)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


CECTestLevelMonitor::~CECTestLevelMonitor()
{}


void CECTestLevelMonitor::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECTestLevelMonitor)
    DDX_Control(pDX, IDC_XTESTMONCTRL, m_XTestMon);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECTestLevelMonitor, CFormView)
//{{AFX_MSG_MAP(CECTestLevelMonitor)
ON_WM_SIZE()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECTestLevelMonitor diagnostics

#ifdef _DEBUG
void CECTestLevelMonitor::AssertValid() const
{
    CFormView::AssertValid();
}

void CECTestLevelMonitor::Dump(CDumpContext& dc) const
{
    CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CECTestLevelMonitor message handlers

void CECTestLevelMonitor::OnSize(UINT nType, int cx, int cy)
{
    CFormView::OnSize(nType, cx, cy);

    if (m_XTestMon.m_hWnd != NULL)
    {
        m_XTestMon.SetWindowPos(NULL, 0,0,cx,cy,SWP_NOZORDER);
    }
}

void CECTestLevelMonitor::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();

    CECClipboard cb;
    CString testRegName = cb.GetClipboardText();

    m_XTestMon.XShowTestStatus(testRegName);
    GetDocument()->SetTitle("Detailed Test Monitor");


    CRect r;
    GetClientRect(r);
    m_XTestMon.SetWindowPos(NULL, 0,0,r.Width(),r.Height(),SWP_NOZORDER);

    SIZE sz= {0};
    SetScrollSizes(MM_TEXT,sz);
}

BEGIN_EVENTSINK_MAP(CECTestLevelMonitor, CFormView)
//{{AFX_EVENTSINK_MAP(CECTestLevelMonitor)
ON_EVENT(CECTestLevelMonitor, IDC_XTESTMONCTRL, 1 /* XUpdateActiveTestName */, OnXUpdateActiveTestName, VTS_BSTR)
ON_EVENT(CECTestLevelMonitor, IDC_XTESTMONCTRL, 2 /* ShowDynGraph */, OnShowDynGraphXtestmonctrl, VTS_BSTR)
ON_EVENT(CECTestLevelMonitor, IDC_XTESTMONCTRL, 3 /* ClosingControl */, OnClosingControlXtestmonctrl, VTS_NONE)
//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CECTestLevelMonitor::OnXUpdateActiveTestName(LPCTSTR strTestName)
{
    CString title;
    title.Format("Detailed Test Monitor - %s", strTestName);
    GetDocument()->SetTitle(title);

}

BOOL CECTestLevelMonitor::OnEraseBkgnd(CDC *pDC)
{
    return true;
}

void CECTestLevelMonitor::OnShowDynGraphXtestmonctrl(LPCTSTR strRegManager)
{
    CWnd* pMainWnd = AfxGetMainWnd();

    CString monitorInfo;
    monitorInfo.Format("%s|%s|" ,SOLUTIONS_GENERIC_DLL ,strRegManager);

    pMainWnd->SendMessage (WMU_FIRE_SPECIFIC_EVENT
                           ,(WPARAM )WMU_DYN_TEST_GRAPH
                           ,(LPARAM) &monitorInfo);
}

void CECTestLevelMonitor::OnClosingControlXtestmonctrl()
{
    GetParentFrame()->DestroyWindow();
}
