/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECDocManager | Over-ridden document manager
//
////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CECDocManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// @mfunc   Constructor
CECDocManager::CECDocManager()
{
}

/////////////////////////////////////////////////////////////////////////////
// @mfunc   Destructor

CECDocManager::~CECDocManager()
{
}

/////////////////////////////////////////////////////////////////////////////
// @mfunc   Creates a new document of the specified type
// @rdesc   The created document

CDocument *CECDocManager::OnFileNew(LPCTSTR DocIdent)   //@parm String containing the document name eg. "MyDoc"
{

    //
    // Check for an empty template list
    //
    if (m_templateList.IsEmpty())
    {
        TRACE0("Error: no document templates registered with CWinApp.\n");
        AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
        return NULL;
    }

    //
    // Search for the document template looking for the Doc Ident string
    //
    CDocTemplate* pTemplate=NULL;

    if (m_templateList.GetCount() > 1)
    {
        // more than one document template to choose from
        POSITION p;
        BOOL DocNotFound=TRUE;
        for(p=m_templateList.GetHeadPosition();p!=NULL;)
        {
            CString templatename;
            CDocTemplate* dt=(CDocTemplate *)m_templateList.GetNext(p);
            dt->GetDocString(templatename,CDocTemplate::fileNewName);
            if(templatename==DocIdent)
            {
                pTemplate=dt;
                DocNotFound=FALSE;
                break;
            }
        }

        // or bring up dialog prompting user to comply with the default
        if(DocNotFound)
        {
            CDocManager::OnFileNew(); //use the old system
            return NULL;
        }
    }

    else
        pTemplate = (CDocTemplate*)m_templateList.GetHead();

    ASSERT(pTemplate != NULL);
    ASSERT_KINDOF(CDocTemplate, pTemplate);

    CDocument * newdoc=pTemplate->OpenDocumentFile(NULL);
    return newdoc;
}
