/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECGraphCustomize | Property Sheet for graph customization
//
////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_CECGRAPHCUSTOMIZE_H__B2B050D9_3856_11D3_BE0D_00A02456D506__INCLUDED_)
#define AFX_CECGRAPHCUSTOMIZE_H__B2B050D9_3856_11D3_BE0D_00A02456D506__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECGraphCustomize.h : header file
//
#include "CECCustomizeTitle.h"
#include "CECCustomizeGraph.h"

/////////////////////////////////////////////////////////////////////////////
// CECGraphCustomize

// @class Property Sheet for graph customization
// @base public | CPropertySheet
class CECGraphCustomize : public CPropertySheet
{
    DECLARE_DYNAMIC(CECGraphCustomize)


    // @access Public Members
public:
    typedef enum {enAreaGraph,enLineGraph,enVBarGraph}GraphStyles;

    // @cmember Constructor
    CECGraphCustomize(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

    // @cmember Constructor
    CECGraphCustomize(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

    // @cmember Title Page
    CECCustomizeTitle   m_TitlePage;

    // @cmember Graph Display Page
    CECCustomizeGraph   m_GraphPage;


    // @access Public Members
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECGraphCustomize)
public:
    virtual BOOL OnInitDialog();
    //}}AFX_VIRTUAL

    // Implementation
public:

    // @cmember Sets the current graph display style
    void SetGraphStyle(int nStyle);

    //Accepts a graph type as defined in mschart.ocx
    void SetChartStyle(int nStyle);

    // @cmember Returns the new graph display style
    int GetGraphStyle();

    //returns the graph styl using type in mschart.ocx
    int GetChartStyle();

    // @cmember Destructor
    virtual ~CECGraphCustomize();

    // Generated message map functions
protected:
    //{{AFX_MSG(CECGraphCustomize)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()



    // @access Private Members
private:

    // @cmember Graph display style
    GraphStyles m_nStyle;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECGRAPHCUSTOMIZE_H__B2B050D9_3856_11D3_BE0D_00A02456D506__INCLUDED_)
