/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECRunList | Floating window showing test runs loaded into the hidden
//          grid. Graph displays will show results for the selected runs in this
//          window.
//
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECRUNLIST_H__1974E8AC_32C3_11D3_BE09_00A02456D506__INCLUDED_)
#define AFX_CECRUNLIST_H__1974E8AC_32C3_11D3_BE09_00A02456D506__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECRunList.h : header file
//

#include "AnalyzerDefs.h"
/////////////////////////////////////////////////////////////////////////////
// CECRunList dialog

// @class Floating run selection window
// @base public | CDialog
class CECRunList : public CDialog
{
    // Construction

    // @access Public Members
public:

    // @cmember Returns the index positions of the selected runs
    CString GetConfigString();

    // @cmember Clears the list box
    void Clear();

    // @cmember Add a test run name into the list box
    void AddRunName(CString strRunName);
    void UpdateGraphsList();

    // @cmember Constructor
    CECRunList(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CECRunList)
    enum { IDD = IDD_RUNLIST };
    CCheckListBox   m_ctlGraphs;
    CListBox    m_ctlTestRuns;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECRunList)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation

    // @access Protected Members
protected:

    // Generated message map functions
    //{{AFX_MSG(CECRunList)
    afx_msg void OnDestroy();
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnClose();
    afx_msg void OnSelchangeRuns();
    afx_msg void OnSelchangeGraphs();
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnCaptureChanged(CWnd *pWnd);
    afx_msg void OnDblclkGraphs();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CMap< CString, LPCSTR, GraphTypesEnum,GraphTypesEnum > m_mapGraphs;

    int m_nSplitPos;
    const int m_nSplitterWidth;
    bool m_bDraggingSplitter;

    void ResizeWindows();
    void DrawMovingSplitter();
};



/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECRUNLIST_H__1974E8AC_32C3_11D3_BE09_00A02456D506__INCLUDED_)
