/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// SelectNodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "SelectNodeDlg.h"
#include "Winsock2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectNodeDlg dialog


CSelectNodeDlg::CSelectNodeDlg(const CStringArray& arstrNodes,CWnd* pParent)
        : CDialog(CSelectNodeDlg::IDD, pParent),
        m_arstrNodes(arstrNodes)
{
    //{{AFX_DATA_INIT(CSelectNodeDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}



void CSelectNodeDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSelectNodeDlg)
    DDX_Control(pDX, IDC_INJECTOR_COMBO, m_ctlInjectorCombo);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CSelectNodeDlg, CDialog)
//{{AFX_MSG_MAP(CSelectNodeDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectNodeDlg message handlers

BOOL CSelectNodeDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CString strNode;
    int nIndex = 0;
    for(int nNode=0;nNode<m_arstrNodes.GetSize();nNode++)
    {
        strNode = GetComputerNameFromIP(m_arstrNodes[nNode]);

        if(m_ctlInjectorCombo.FindString(-1,strNode)==CB_ERR)
        {
            nIndex = m_ctlInjectorCombo.AddString(strNode);
            m_ctlInjectorCombo.SetItemData(nIndex,nNode);
        }
    }

    strNode = GetComputerNameFromIP(m_strSelectedNode);
    if(m_ctlInjectorCombo.SelectString(-1,strNode) == CB_ERR)
        m_ctlInjectorCombo.SetCurSel(0);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CSelectNodeDlg::OnOK()
{
    int nSel = m_ctlInjectorCombo.GetCurSel();
    if(nSel != CB_ERR)
    {
        DWORD dwData = m_ctlInjectorCombo.GetItemData(nSel);
        m_strSelectedNode = m_arstrNodes[dwData];
    }

    CDialog::OnOK();
}

CString CSelectNodeDlg::GetComputerNameFromIP(const CString& strIP)
{
    CString strName;
    if(m_mapIPToName.Lookup(strIP,strName))
        return strName;

    CString strIPCopy(strIP);
    strIPCopy.Replace('_','.');
    DWORD dwAddr = inet_addr(strIPCopy);

    HOSTENT *pHost = gethostbyaddr((char*)&dwAddr,4,AF_INET);
    if(pHost==NULL)
    {
        TRACE("Net error %d\n",WSAGetLastError());
        strName = strIP;
    }
    else
    {
        strName = pHost->h_name;
        strName = strName.SpanExcluding(".");
        strName.MakeUpper();
    }
    m_mapIPToName.SetAt(strIP,strName);
    return strName;
}
