#if !defined(AFX_TABBEDCHILDFRAME_H__9F0F39C3_F407_11D3_BD83_00C04F89E392__INCLUDED_)
#define AFX_TABBEDCHILDFRAME_H__9F0F39C3_F407_11D3_BD83_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TabbedChildFrame.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTabbedChildFrame frame
#include "AnalyzerSheet.h"

class CTabbedChildFrame : public CAnalyzerSheet
{
    DECLARE_DYNCREATE(CTabbedChildFrame)
protected:
    CTabbedChildFrame();           // protected constructor used by dynamic creation

    // Attributes
public:
    BOOL IsInitialised()
    {
        return m_bInitialised;
    }
    void SetInitialised()
    {
        m_bInitialised = true;
    }
    // Operations
public:
    BOOL AddTab(CRuntimeClass *pViewRTC,const CString& strLabel);
    BOOL AddTab(CView *pView,const CString& strLabel);
    BOOL RemoveTab(int nIndex);
    int GetTabCount();
    BOOL GetTabInfo(int nNdx,CString& strLabel,CWnd*& pWnd);
    int GetTabIndex(const CString& strLabel);

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CTabbedChildFrame)
protected:
    virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    virtual ~CTabbedChildFrame();

    // Generated message map functions
    //{{AFX_MSG(CTabbedChildFrame)
    afx_msg void OnDestroy();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    //}}AFX_MSG
    afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
    DECLARE_MESSAGE_MAP()

    BOOL m_bInitialised;

    CArray <CView*,CView*> m_arViews;

    CView *m_pCurrentView;

    void UpdateView();

    CTabCtrl m_TabCtrl;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TABBEDCHILDFRAME_H__9F0F39C3_F407_11D3_BD83_00C04F89E392__INCLUDED_)
