#if !defined(AFX_TABBEDDOC_H__9F0F39C6_F407_11D3_BD83_00C04F89E392__INCLUDED_)
#define AFX_TABBEDDOC_H__9F0F39C6_F407_11D3_BD83_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TabbedDoc.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTabbedDoc document

#include "AnalyzerDoc.h"
#include "AnalyzerDefs.h"
class CTabbedChildFrame;
class CGraphTypeBase;
class CGraphView;

class CTabbedDoc : public CAnalyzerDoc
{
protected:
    CTabbedDoc();           // protected constructor used by dynamic creation
    DECLARE_DYNCREATE(CTabbedDoc)

    // Attributes
public:

    // Operations
public:
    void SetupGraph(GraphTypesEnum nGraphType,CTabbedChildFrame* pFrame);
    CTabbedChildFrame* GetFrame()
    {
        return m_pTabbedFrame;
    }

    void UpdateTabs();
    void RemoveAllTabs();
    void UpdateCombinedRun(int nRunIndex);

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CTabbedDoc)
public:
    virtual void Serialize(CArchive& ar);   // overridden for document i/o
protected:
    virtual BOOL OnNewDocument();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CTabbedDoc();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CTabbedDoc)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CTabbedChildFrame *m_pTabbedFrame;
    GraphTypesEnum m_nGraphType;

    BOOL m_bNeedsFrequencyData;
    BOOL m_bNeedsTimers;
    BOOL m_bNeedsOTA;
    BOOL m_bNeedsHttp;
    BOOL m_bHasCombined;
    CRuntimeClass *m_prtcViewClass;
    CView *m_pCombinedView;

    CString FormatRunName(const CString& strRunName);
    CGraphTypeBase *CreateNewGraph(CGraphView *);
    BOOL RemoveTab(int nTabNdx);
    BOOL AddTab(const CString& strTabName,int nTestRun);

    BOOL AddCombinedData(int nTestRun);
    BOOL RemoveCombinedData(int nTestRun);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TABBEDDOC_H__9F0F39C6_F407_11D3_BD83_00C04F89E392__INCLUDED_)
