/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRProjectTools.h
// -----------------
//
//    This is the include file for the CYRProjectTools class
//
//=========================================================================
#if !defined(AFX_CYRPROJECTTOOLS_H__55C45913_248F_11D3_B6AF_00600856D1F5__INCLUDED_)
#define AFX_CYRPROJECTTOOLS_H__55C45913_248F_11D3_B6AF_00600856D1F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CYRProjectTools window

class CYRProjectTools : public CObject
{
    // Construction
public:
    CYRProjectTools();

    // Operations
public:

    // Routine to determine if a file is already open in the MDI Client Window
    BOOL DoesDocumentExist(CDocTemplate* pDocTemplate, CString szPath, BOOL bActivate = TRUE);

    // get a count of the number of open documents
    int GetDocumentCount(CDocTemplate* pDocTemplate);

    // Get hold of the current document
    BOOL GetActiveDocument(CDocTemplate* pDocTemplate, CString& szFile);

    // Returns the active view
    CView* GetActiveView();

    // Extract a File Title from a file path
    BOOL ExtractFileTitle(CString& szFile);

    // Strip off a trailing slash from a file path
    BOOL StripOffTrailingSlash(CString& szFile);

    // Implementation
public:
    virtual ~CYRProjectTools();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYRPROJECTTOOLS_H__55C45913_248F_11D3_B6AF_00600856D1F5__INCLUDED_)
