/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRThreadSummary.cpp
// --------------------
//
//    This is the implementation file for the CYRThreadSummary class
//
//=========================================================================

#include "stdafx.h"
#include "resource.h"

#include "CYRThreadSummary.h"
#include "CYRThreadInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYRThreadSummary dialog


CYRThreadSummary::CYRThreadSummary(CWnd* pParent /*=NULL*/)
        : CDialog(CYRThreadSummary::IDD, pParent)
{
    //{{AFX_DATA_INIT(CYRThreadSummary)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}



void CYRThreadSummary::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CYRThreadSummary)
    DDX_Control(pDX, IDC_LIST, m_ThreadList);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CYRThreadSummary, CDialog)
//{{AFX_MSG_MAP(CYRThreadSummary)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CYRThreadSummary message handlers

BOOL CYRThreadSummary::OnInitDialog()
{
    CDialog::OnInitDialog();

    CYRThreadInfo* pThread = NULL;

    // Set up the Column Headings
    CString szTerminal  = pThread->GetTitle(CYRThreadInfo::NAME);
    CString szDevice    = pThread->GetTitle(CYRThreadInfo::DEVICE);
    CString szNode      = pThread->GetTitle(CYRThreadInfo::NODE);
    CString szScript    = pThread->GetTitle(CYRThreadInfo::SCRIPT);
    CString szStart     = pThread->GetTitle(CYRThreadInfo::TIME);
    CString szStatus    = pThread->GetTitle(CYRThreadInfo::STATUS);
    CString szSequence  = pThread->GetTitle(CYRThreadInfo::SEQUENCE);
    CString szType      = pThread->GetTitle(CYRThreadInfo::TYPE);
    CString szMessage   = pThread->GetTitle(CYRThreadInfo::MESSAGE);

    CString szColumns = szTerminal  + "@*.40|" +
                        szDevice    + "@*.40|" +
                        szNode      + "@*.40|" +
                        szScript    + "@*.40|" +
                        szStart     + "@*.40|" +
                        szStatus    + "@*.40|" +
                        szSequence  + "@*.40|" +
                        szType      + "@*.40|" +
                        szMessage   + "@*.40||1";

    m_ThreadList.SetHeaderString(szColumns);


    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

//
// SetData
// =======
//
// This function is called with the Thread Summary Info to set up a complete
// row of information

void CYRThreadSummary::SetData(CYRThreadInfo* pThread)
{
    // Increment the index as the List Control is not zero based
    int row = pThread->GetIndex() + 1;

    m_ThreadList.SetValue(row,1,COleVariant( pThread->GetValue(CYRThreadInfo::NAME)));
    m_ThreadList.SetValue(row,2,COleVariant( pThread->GetValue(CYRThreadInfo::DEVICE)));
    m_ThreadList.SetValue(row,3,COleVariant( pThread->GetValue(CYRThreadInfo::NODE)));
    m_ThreadList.SetValue(row,4,COleVariant( pThread->GetValue(CYRThreadInfo::SCRIPT)));
    m_ThreadList.SetValue(row,5,COleVariant( pThread->GetValue(CYRThreadInfo::TIME)));
    m_ThreadList.SetValue(row,6,COleVariant( pThread->GetValue(CYRThreadInfo::STATUS)));
    m_ThreadList.SetValue(row,7,COleVariant( pThread->GetValue(CYRThreadInfo::SEQUENCE)));
    m_ThreadList.SetValue(row,8,COleVariant( pThread->GetValue(CYRThreadInfo::TYPE)));
    m_ThreadList.SetValue(row,9,COleVariant( pThread->GetValue(CYRThreadInfo::MESSAGE)));
}
