/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRThreadPropertiesDlg.h
// ------------------------
//
//    This is the include file for the CYRThreadPropertiesDlg class.
//
//=========================================================================

#if !defined(AFX_CYRThreadPropertiesDlg_H__965B0CFA_6C12_11D3_9F2F_00500487BD9B__INCLUDED_)
#define AFX_CYRThreadPropertiesDlg_H__965B0CFA_6C12_11D3_9F2F_00500487BD9B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CYRThreadPropertiesDlg.h : header file
//
#include "..\..\Common\CECTestObject.h"
#include "..\..\Common\CECDataName.h"

/////////////////////////////////////////////////////////////////////////////
// CYRThreadPropertiesDlg dialog

class CYRThreadPropertiesDlg : public CDialog
{
    // Construction
public:
    CYRThreadPropertiesDlg(CWnd* pParent = NULL);   // standard constructor

    // Dialog Controls
    CSpinButtonCtrl* m_pSpinUserThreads;
    CSpinButtonCtrl* m_pSpinInterval;

    // Dialog Data
    //{{AFX_DATA(CYRThreadPropertiesDlg)
    enum { IDD = IDD_THREAD_PROPERTIES };
    CSpinButtonCtrl m_SpinInterval;
    CSpinButtonCtrl m_SpinUserThreads;
    CComboBox   m_TargetList;
    CString     m_strThreadName;
    UINT        m_nInterval;
    UINT        m_nUserThreads;
    //}}AFX_DATA

    CString m_szOriginalCBText;

    // Readers + Writers
    UINT GetUserThreads()
    {
        return m_nUserThreads;
    }
    UINT GetInterval()
    {
        return m_nInterval;
    }

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRThreadPropertiesDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    CECThread* m_pThreadProperties;

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRThreadPropertiesDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnExitUserThreads();
    virtual void OnOK();
    virtual void OnCancel();
    afx_msg void OnSelchangeTargetCombo();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    afx_msg void OnUpdateNumber(CCmdUI *pCmdUI);
    afx_msg void OnUpdateInterval(CCmdUI *pCmdUI);
    DECLARE_MESSAGE_MAP()

private:
    CString m_szHtmlHelpFile;
    CECDataName     m_DataNameEdit;

    void PrimeTargetCombo();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYRThreadPropertiesDlg_H__965B0CFA_6C12_11D3_9F2F_00500487BD9B__INCLUDED_)
