#if !defined(AFX_CYRSIMPLETESTWIZARD_H__4174A246_03D1_11D4_BD87_00C04F89E392__INCLUDED_)
#define AFX_CYRSIMPLETESTWIZARD_H__4174A246_03D1_11D4_BD87_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CYRSimpleTestWizard.h : header file
//

#include "..\..\Common\CECDataName.h"
#include "..\..\Common\CECDataNameCombo.h"
#include "CECGridCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CYRWizardBasePage dialog
typedef struct
{
    CString m_strName;
    CString m_strDescription;
    int     m_nPercentage;
}
ScriptProperties;

class CYRWizardBasePage : public CPropertyPage
{
    DECLARE_DYNCREATE(CYRWizardBasePage)

public:
    virtual BOOL OnWizardFinish();

    // Construction
public:
CYRWizardBasePage(int nPageId): CPropertyPage(nPageId)
    {}

    ~CYRWizardBasePage()
    {}


    virtual void SavePageSettings(const CString& strWizardFile)
    {}

    virtual void LoadPageSettings(const CString& strWizardFile)
    {}

    // Implementation

protected:
    CYRWizardBasePage()
    {}

};

/////////////////////////////////////////////////////////////////////////////
// CYRNameDefinitionPage dialog

class CYRNameDefinitionPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRNameDefinitionPage)

    // Construction
public:
    CYRNameDefinitionPage();
    ~CYRNameDefinitionPage();

    // Dialog Data
    //{{AFX_DATA(CYRNameDefinitionPage)
    enum { IDD = IDD_WIZ_NAME_DEFINITION_PAGE1 };
    CString m_strTestDescription;
    CString m_strTestName;
    //}}AFX_DATA
    CECDataName m_ctlTestName;

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);

    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CYRNameDefinitionPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
    virtual void OnOK();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRNameDefinitionPage)
    virtual BOOL OnInitDialog();
    afx_msg void OnSetfocusTestDescription(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private:
    CString m_szHtmlHelpFile;
};

/////////////////////////////////////////////////////////////////////////////
// CYRAuxillaryScriptPage dialog

class CYRAuxillaryScriptPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRAuxillaryScriptPage)

    // Construction
public:
    CYRAuxillaryScriptPage();
    ~CYRAuxillaryScriptPage();

    // Dialog Data
    //{{AFX_DATA(CYRAuxillaryScriptPage)
    enum { IDD = IDD_WIZ_AUXILLARY_SCRIPT_PAGE };
    CString m_strEpilogScript;
    CString m_strPrologScript;
    //}}AFX_DATA
    CECDataNameCombo    m_ctlPrologScript;
    CECDataNameCombo    m_ctlEpilogScript;

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);

    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CYRAuxillaryScriptPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRAuxillaryScriptPage)
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private:
    CString m_szHtmlHelpFile;
};
/////////////////////////////////////////////////////////////////////////////
// CYRScriptDependencyPage dialog

class CYRScriptDependencyPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRScriptDependencyPage)

    // Construction
public:
    CYRScriptDependencyPage();
    ~CYRScriptDependencyPage();

    // Dialog Data
    //{{AFX_DATA(CYRScriptDependencyPage)
    enum { IDD = IDD_WIZ_SCRIPT_DEPENDENCY_PAGE };
    CButton m_ctlRemove;
    CButton m_ctlModify;
    CListCtrl   m_ctlScripts;
    //}}AFX_DATA

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);

    int GetNumScripts()
    {
        return m_arScripts.GetSize();
    }
    const ScriptProperties& GetScript(int nNdx)
    {
        return m_arScripts[nNdx];
    }
    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CYRScriptDependencyPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    virtual LRESULT OnWizardBack();

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRScriptDependencyPage)
    virtual BOOL OnInitDialog();
    afx_msg void OnAdd();
    afx_msg void OnModify();
    afx_msg void OnRemove();
    afx_msg void OnItemchangedScripts(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    afx_msg void OnUpdateAdd(CCmdUI *pCmdUI);
    afx_msg void OnUpdateModify(CCmdUI *pCmdUI);
    afx_msg void OnUpdateRemove(CCmdUI *pCmdUI);
    DECLARE_MESSAGE_MAP()

    CArray <ScriptProperties,ScriptProperties> m_arScripts;
    int m_nTotalPCUsed;
    BOOL m_bAdvancedMode;
private:
    BOOL m_bOnBack;
    CString m_szHtmlHelpFile;
};
/////////////////////////////////////////////////////////////////////////////
// CYRBrowserRatioPage dialog
typedef struct 
{
        CString strName;
        CString strUserAgent;
        int nPercent;
}BrowserInfo;

class CYRBrowserRatioPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRBrowserRatioPage)

    // Construction
public:
    CString GetStatLevel();
    CYRBrowserRatioPage();
    ~CYRBrowserRatioPage();

    // Dialog Data
    //{{AFX_DATA(CYRBrowserRatioPage)
	enum { IDD = IDD_WIZ_BROWSER_RATIO_PAGE };
    CComboBox   m_StatLevel;
    int     m_nNumIterations;
    int     m_nNumSimUsers;
    int     m_nIterationDelay;
	int		m_nMaxIterationDelay;
	int		m_nMinIterationDelay;
	int		m_bRandomIterationDelay;
	BOOL	m_bGenPageTimers;
	//}}AFX_DATA

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);
    int GetNumBrowserTypes()
    {
        return m_arBrowsers.GetSize();
    }
    const BrowserInfo& GetBrowser(int nNdx)
    {
        return m_arBrowsers[nNdx];
    }

    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CYRBrowserRatioPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRBrowserRatioPage)
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnRandomDelay();
	afx_msg void OnConstantDelay();
	afx_msg void OnBrowserTypes();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CArray <BrowserInfo,BrowserInfo&> m_arBrowsers;

    void UpdateListOfBrowsers();
private:
    int m_nStatLev;
    CString m_szHtmlHelpFile;
};

/////////////////////////////////////////////////////////////////////////////
// CYRSummaryPage dialog

class CYRSummaryPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRSummaryPage)

    // Construction
public:
    CYRSummaryPage();    // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRSummaryPage)
    enum { IDD = IDD_WIZ_SUMMARY_PAGE };
    CEdit   m_ctlSummary;
    CString m_strSummary;
    //}}AFX_DATA

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRSummaryPage)
public:
    virtual BOOL OnSetActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRSummaryPage)
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    void ComposeSummary();
private:
    CString m_szHtmlHelpFile;
    BOOL m_bAdvanced;
};

/////////////////////////////////////////////////////////////////////////////
// CYRModeSelectionPage dialog

class CYRModeSelectionPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRModeSelectionPage)

    // Construction
public:
    CYRModeSelectionPage();
    ~CYRModeSelectionPage();

    // Dialog Data
    //{{AFX_DATA(CYRModeSelectionPage)
    enum { IDD = IDD_WIZ_MODE_SELECTION_PAGE };
    // NOTE - ClassWizard will add data members here.
    //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_DATA

    BOOL m_bAdvancedMode;
    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);
    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CYRModeSelectionPage)
public:
    virtual LRESULT OnWizardNext();
    virtual BOOL OnSetActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CYRModeSelectionPage)
    afx_msg void OnAdvanced();
    afx_msg void OnStandard();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CYRSimpleTestWizardSheet
class CYRServer;
class CYRSimpleTestWizardSheet : public CPropertySheet
{
    DECLARE_DYNAMIC(CYRSimpleTestWizardSheet)

    typedef enum {enModeSelPage,enNameDefPage,enAuxScriptPage,enScriptDepPage,enBrowserRatioPage,enSummaryPage,enMaxPageNdx} PageNdxs;

    // Construction
public:
    CYRSimpleTestWizardSheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0,const CString& strTestName = "");
    CYRSimpleTestWizardSheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0,const CString& strTestName = "");

    bool IsValidFilename(const CString &strPath,bool bTellUser=true);
    // Attributes
public:

    // Operations
public:
    CYRServer *m_pServer;

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRSimpleTestWizardSheet)
public:
    virtual BOOL OnInitDialog();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CYRSimpleTestWizardSheet();
    BOOL IsWizardMode()
    {
        return m_bWizardMode;
    }
    void OnWizardFinish();
    void GenerateScripts();
    CYRWizardBasePage* GetPage(int nPage);
    void SetAdvancedMode(BOOL bAdvanced);
    BOOL GetAdvancedMode()
    {
        return m_bAdvancedMode;
    }
    // Generated message map functions
protected:
    //{{AFX_MSG(CYRSimpleTestWizardSheet)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
    void WriteSCL();
    void SetupPages();
    CString GetSCLScriptsString();
    BOOL SetupWizard(const CString& strTest);
    BOOL m_bWizardMode;
    BOOL m_bAdvancedMode;

    CYRModeSelectionPage m_ModeSelPage;
    CYRNameDefinitionPage m_NameDefPage;
    CYRAuxillaryScriptPage m_AuxScriptPage;
    CYRScriptDependencyPage m_ScriptDepPage;
    CYRBrowserRatioPage m_BrowserRatioPage;
    CYRSummaryPage m_SummaryPage;
};

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CYRScriptPropertiesDlg dialog

class CYRScriptPropertiesDlg : public CDialog
{
    // Construction
public:
    CYRScriptPropertiesDlg(ScriptProperties* pScript,int nPercentUsed,CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRScriptPropertiesDlg)
    enum { IDD = IDD_SCRIPT_PROPERTIES_DLG };
    CString m_strDescription;
    int     m_nPercentage;
    CString m_strScriptName;
    //}}AFX_DATA
    CECDataNameCombo    m_ctlScriptName;
    ScriptProperties *m_pScript;

    void SetAdvancedMode(BOOL bAdvanced)
    {
        m_bAdvancedMode = bAdvanced;
    }
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRScriptPropertiesDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRScriptPropertiesDlg)
    virtual BOOL OnInitDialog();
    virtual void OnOK();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    afx_msg void OnSetfocusWizScriptdescription();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    int m_nPercentUsed;

private:
    CString m_szHtmlHelpFile;
    BOOL m_bAdvancedMode;
};

/////////////////////////////////////////////////////////////////////////////
// CYRBrowserTypeDlg dialog

class CYRBrowserTypeDlg : public CDialog
{
// Construction
public:
	CYRBrowserTypeDlg(CArray <BrowserInfo,BrowserInfo&>& arBrowsers,CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CYRBrowserTypeDlg)
	enum { IDD = IDD_BROWSER_TYPE_DLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CYRBrowserTypeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
    CECGridCtrl m_ctlBrowserList;

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CYRBrowserTypeDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SetupBrowserList();

    CArray <BrowserInfo,BrowserInfo&>& m_arBrowsers;
};
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYRSIMPLETESTWIZARD_H__4174A246_03D1_11D4_BD87_00C04F89E392__INCLUDED_)
