/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _CECMUTEXLIST_H_
#define _CECMUTEXLIST_H_
#include "CECMutex.h"
#include <map>
#ifndef CYR_NO_STD_NAMESPACE
using std::map;
#endif
class CECMutexList
{
public:
    CECMutexList();
    virtual ~CECMutexList();
    virtual CECMutex* GetMutex(string name,int scope);
public:
    class MutexId
    {
    public:
        MutexId(string name,int scope);
        virtual ~MutexId();
        string _name;
        int _scope;
        virtual int compare(const MutexId& rhs)const;
        virtual bool operator<(const MutexId& rhs)const
        {
            if(compare(rhs)==-1)
                return true;
            else
                return false;
        }
    };
protected:
    typedef map<MutexId,CECMutex*> mutexmap_t;
    mutexmap_t  m_mutexmap;
};

#if !defined(LINUX) && !defined(HPUX)
bool operator<(const CECMutexList::MutexId& rhs,const CECMutexList::MutexId& lhs);
#endif
#endif
