/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef MDBTHREAD_H
#define MDBTHREAD_H
#ifdef WIN32
#pragma warning(disable:4786)
#endif
#include <string>
#include "TContext.h"
#include "ThreadTask.h"
#include <mthread.hpp>
#include <mutex.hpp>
#if defined(WIN32)
using namespace std;
#endif
class Cthreadcontrol;//threads can call thread control to be given a new task
class Cmdbthread : public TContext
{
public:
    //no default constructor, all threads created in same manner
    Cmdbthread(Cthreadcontrol* threadcontrol,string filename);
    virtual ~Cmdbthread();
    void ActivateThread(void);//start thread running
    void*   start(void);//method used by thread
    bool    run(void);//method invoked by start to actually run script
    void    join(void);
    //void    join(unsigned long milliseconds);
    enumThreadState get_state(void) const ;
    void    end_thread(void);//cancel thread execution
    void    Terminate(void);//terminate thread execution
    bool    ReportStatus();//output message on thread status
protected:
    //To virtual functions to be overridden to put in the Log Messages for starting and ending Threads/Tests
    virtual void LogStartMessage()=0;
    virtual void LogEndMessage()=0;
    void    exception_abort(string reason);
    Cthreadcontrol* m_threadcontrol;
    string  abort_message;

private:
    ThreadTask*     taskP;
    CTThread* m_running_thread;
};

#endif
