/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _TETHREADCONTROL_H_
#define _TETHREADCONTROL_H_
///////////////////////////////////////////////////////////////////////////////
// @doc     TEThreadcontrol
// @module  TEThreadcontrol| Derived threadcontrol classes for Test Executers
//
///////////////////////////////////////////////////////////////////////////////
#include "threadcontrol.h"
#include "CORBARepository.h"
#include "TEThread.h"
#ifndef CYRANO_TP_STANDALONE
typedef map<string, ThreadInfo > ThreadMap_t;
#endif
template <class T> class Threadcontrol:public Cthreadcontrol
{
public:
#ifndef CYRANO_TP_STANDALONE
    ThreadMap_t         ThreadMap;
#endif
    // Constructor/Destructor
Threadcontrol(TScriptRule* rule):Cthreadcontrol(rule)
    {}
    ;
Threadcontrol(TScriptRule* rule, int max_threads):Cthreadcontrol(rule,max_threads)
    {}
    ;
    virtual ~Threadcontrol()
    {}
    ;
    virtual int AttachThread(const char* TofFile
#ifndef CYRANO_TP_STANDALONE
                             ,TestLevel_ptr pTL,const ThreadDef & thrdef
#endif
                            )
    {
        logr->AddTrace(DBGSTD,DEBUGLEVEL,"Trying to attach New Thread");
        string message = TofFile;
        Repository->LogMessage(message.c_str(), AUDITMSG);
        if(threads.size() >= maxthrd)
        {
            logr->AddTrace(DBGSTD,DEBUGLEVEL,"Have used maximum number of Threads for this test executer");
#ifndef CYRANO_TP_STANDALONE
            throw CyrNoFreeThreadException();
#endif
        }
        T* ptr_thread=new T(this,message);
        assert(ptr_thread);
        threads.push_back(ptr_thread);
        if(ptr_thread==NULL)return -1;
#ifndef CYRANO_TP_STANDALONE
        ptr_thread->SetThreadInfo(pTL->TestName(),thrdef);
#endif
        // Pass in File name details
        logr->AddTrace(DBGSTD,DEBUGLEVEL,"Start New Thread Running");
        ptr_thread->ActivateThread();

        return 0;
    }// End of AttachThread
}
;
typedef Threadcontrol<TEThread> TEthreadcontrol;
#endif
