/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc SNMP
///////////////////////////////////////////////////////////////////////////////

#ifndef _OtaSnmp_h
#define _OtaSnmp_h

#include "OtaQueryHandler.h"

///////////////////////////////////////////////////////////////////////////////
// Standard includes
#include <string>
#ifndef VMS
using std::string;
#endif

#include <list>
using std::list;

#ifdef WIN32
#pragma warning(disable:4786)
#pragma warning(disable:4503)
#endif

///////////////////////////////////////////////////////////////////////////////
// @class   CyrSnmp | This class allows the querying and retrieval of
//          SNMP statistics.
// @base    public | _sk_CyrOTAQueryHandler
class OtaSnmp : public virtual OtaQueryHandler
{
    // @access Public Members
public:
    OtaSnmp();                                  // @cmember Constructor
    virtual ~OtaSnmp();                         // @cmember Destructor

    // @access IDL Generated Methods
    bool RunSimpleQuery( const string query, long *result );       // @cmember Runs simple query
    bool RunDetailedQuery( const string query, string *result );   // @cmember Runs detailed query
    string GetDetailedHeaders( const string query );  // @cmember Gets detailed query headers

    // @access Private Members
private:

};

#endif
