#ifndef PSL__TPG_COMDEF_LOADED
#define PSL__TPG_COMDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*
 *  tpg_comdef.h:
 *  =============
 *
 *  Include File containing TPG Commmon Data Structure definition.
 */

struct tpg_com
{
    /*
     *  Command Line Parsing information.
     */
    struct tpg_cmd *cmd_ptrps;
    /*
     *  Expanded File Specifications.
     */
    char tpg_namec256[256];     /* TPG File */
    char out_namec256[256];     /* Ouput File */
    char func_namec256[256];    /* Function File */
    /*
     *  Pointers to files.
     */
    FILE *tpg_file_ptrpf;
    FILE *out_file_ptrpf;
    FILE *func_file_ptrpf;
    /*
     *  Pointer to Diagnostics Stack.
     */
    struct diagstk *diagstkps;
    /*
     *  Count of the number of errors encountered during parsing.
     */
    unsigned long err_countl;
    /*
     *  Line Count.
     */
    unsigned long line_countl;
    /*
     *  Pointer to Listing Context Block.
     */
    struct list_ctx *list_ctx_ptrps;
    /*
     *  Pointer to Tparse Data Structure.
     */
    struct tpg_tpa *tpa_ptrps;

};
#endif  /* PSL__TPG_COMDEF_LOADED */

/*  End of Include File  */
