/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*
 *    TARGET_RTNDEF.H                                * 
 *    ==================                             * 
 *                                       * 
 *    This module contains the header file for the PSL_TARGET_RTNS routines  * 
 *                                       *
 *===========================================================================*/

/*
 *    Only load if not already loaded 
 */
#ifndef CYR_EXECUTERDEFS_Loaded
#define CYR_EXECUTERDEFS_Loaded

#include <sysshr_rtns.h>

/*
 *    Define the symbolic values for the target ID's 
 */
enum TARGETID {TARGET_UNKNOWN = -1 ,TARGET_FILLER ,TARGET_SYBASE ,TARGET_ORACLE
               ,TARGET_SQLSERVER ,TARGET_ORACLE8
               ,TARGET_ORACLEAPP ,TARGET_TUXEDO ,TARGET_SAP ,TARGET_TCPIP,TARGET_COMMAND,TARGET_HTTP ,TARGET_OTA};

/*
 *    Define the symbolic values for the executer ID's 
 */
enum EXECUTERID {EXECUTER_UNKNOWN = -1 ,EXECUTER_CTEST ,EXECUTER_ROBOT ,EXECUTER_WINDOWS ,EXECUTER_SYBASE
                 ,EXECUTER_WEBANALYZER ,EXECUTER_ORACLE ,EXECUTER_SQLSERVER ,EXECUTER_ORACLE8
                 ,EXECUTER_ORACLEAPP ,EXECUTER_TUXEDO  ,EXECUTER_SAP ,EXECUTER_TCPIP
                 ,EXECUTER_CMD,EXECUTER_HTTP,EXECUTER_OTA};

/*
 *    Images associated with the targets 
 */
enum TARGETIMAGE {SELECT ,WHERE ,WHILE ,TEXECUTER ,TMANAGER};

/*
 *    Functions 
 */
enum TARGETID   Tgt_GetTargetID     (char* pTargetString);

int     Tgt_GetTarget       (enum TARGETID TargetID ,char* pBuff ,int BuffLen ,Boolean ReturnDisplayed);

int     Tgt_GetSuffix       (enum TARGETID TargetID ,char* pBuff ,int BuffLen);

int     Tgt_GetExecuterList (char* pBuff ,int BuffLen);

int     Tgt_GetTargetList   (char* pBuff ,int BuffLen ,Boolean ReturnDisplayed);

int     Tgt_OtaForTarget    (enum TARGETID TargetID);

void        Tgt_GetTargetExecutable (enum TARGETID TargetID ,enum TARGETIMAGE image ,char* Buff ,int BuffLen);

int     Tgt_GetCYRANOImpactPathForTarget(char* Buff , unsigned int BuffLen);

#endif
